﻿var queryFilters = new Array();
var divFilterPanel = null;
var ddlFilterCol = null;
var btnFilterFn = null;
var ddlFilterCondi = null;
var tbFilterValue = null;
var ddlFilterNlc = null;
var rbFilterEnc = null;
var hidFilterRowNum = null;
var btnFilterSave = null;

function InitializeFiltersPanel()
{
    divFilterPanel = document.getElementsByName("pnlAddEditFiltersPanel")[0];
    ddlFilterCol = document.getElementsByName("ddlcolaefi")[0];
    btnFilterFn = document.getElementsByName("btnfncaefi")[0];
    ddlFilterCondi = document.getElementsByName("ddlconaefi")[0];
    tbFilterValue = document.getElementsByName("tbvalueaefi")[0];
    ddlFilterNlc = document.getElementsByName("ddlnlcaefi")[0];
    rbFilterEnc = document.getElementsByName("rbencloaefi");
    hidFilterRowNum = document.getElementsByName("aefirownum")[0];
    btnFilterSave = document.getElementsByName("btnsaveaefi")[0];
}

function QueryFilter(columnName, condition, value, connector, enclosure)
{
    this.columnName = columnName;
    this.condition = condition;
    this.value = value;
    this.enclosure = enclosure;
    this.connector = connector;
    this.filterSyntax = columnName + " " + condition + " " + value;
    if (this.enclosure == "L")
    {
        this.filterSyntax = "(" + this.filterSyntax;
    }
    else if (this.enclosure == "R")
    {
        this.filterSyntax += this.filterSyntax + ")";
    }
    else if (this.enclosure == "O")
    {
        this.filterSyntax = "(" + this.filterSyntax + ")";
    }
}

function BuildAllQueryFilters()
{
    var allFilterConditions = "";
    if (queryFilters.length > 0)
    {
        allFilterConditions += "WHERE\t\t";
        for (var i=0; i<queryFilters.length; i++)
        {
            allFilterConditions += queryFilters[i].filterSyntax + "\t" + queryFilters[i].connector;
            allFilterConditions += "\n\t\t";
        }
    }
    return allFilterConditions;
}

function RepopulateFilterColumnRows()
{
    var tmpColumnNamesListForFilters = new Array();
    for (var i=0; i<columnNamesListForFilters.length; i++)
    {
        tmpColumnNamesListForFilters[tmpColumnNamesListForFilters.length] = columnNamesListForFilters[i];
    }
    thisDropDownList = ddlFilterCol;
    thisDropDownListValue = thisDropDownList.value;
    FillDropDownList(thisDropDownList, thisDropDownListValue, tmpColumnNamesListForFilters, tmpColumnNamesListForFilters, true);
}

function btnAddFilter_OnClick()
{
    if (dbColumns.length == 0) { alert("Please select some tables first"); ReplicateBodyOnLoad(); return false;}
    var tmpColumnNamesListForFilters = new Array();
    for (var i=0; i<columnNamesListForFilters.length; i++)
    {
        tmpColumnNamesListForFilters[tmpColumnNamesListForFilters.length] = columnNamesListForFilters[i];
    }
    ShowPopups_AddEditFilterCondition();
    return false;
}

function ShowPopups_AddEditFilterCondition()
{
    divFilterPanel.style.display = "block";
    CenterIt(divFilterPanel);
    ddlFilterCol.focus();
}

function HidePopups_AddEditFilterCondition()
{
    ddlFilterCol.selectedIndex = 0;
    tbFilterValue.value = "";
    ddlFilterCondi.selectedIndex = 0;
    ddlFilterNlc.selectedIndex = 0;
    for (var i=0; i<rbFilterEnc.length; i++)
    {
        rbFilterEnc.checked = false;
    }
    hidFilterRowNum.value = "-1";
    divFilterPanel.style.display = "none";
    HidePopups_AddFunction();
}

function btnsaveaefi_OnClick()
{
    col = trim(ddlFilterCol.value);
    cond = trim(ddlFilterCondi.value);
    val = tbFilterValue.value;
    nlc = ddlFilterNlc.value;
    enc = "";
    if (val.length == 0)
    {
        alert("Please specify a value or sub query for the filter condition");
        tbFilterValue.focus();
        return false;
    }
    for (var i=0; i<rbFilterEnc.length; i++)
    {
        if (rbFilterEnc.checked)
        {
            enc = rbFilterEnc.value;
            break;
        }
    }
    rowNumber = parseInt(hidFilterRowNum.value, 10);
    isNewRow = hidFilterRowNum.value == "-1";
    if (queryFilters.length != 0)
    {
        if (isNewRow) 
        { 
            rowNumberBefore = queryFilters.length - 1; 
            rowNumberAfter = -1;
        }
        else 
        {
            rowNumberBefore = rowNumber - 1;
            rowNumberAfter = (rowNumber == queryFilters.length-1) ? -1 : rowNumber + 1;
        }
        errorInConnector = false;
        connectorErrorMessage = "";
        if (rowNumberBefore >= 0)
        {
            if (queryFilters[rowNumberBefore].connector == "")
            {
                connectorErrorMessage = "Please make sure that previous filter condition has a connector defined to link with this filter condition, else your query will fail.\n";
                errorInConnector = true;
            }
        }
        if (rowNumberAfter >= 1)
        {
            if (nlc == "")
            {
                connectorErrorMessage += "Please make sure that this filter condition has a connector defined to link with next filter condition, else your query will fail.\n";
                errorInConnector = true;
            }
        }
        if (errorInConnector)
        {
            alert(connectorErrorMessage);
        }
    }
    tmpQueryFilter = new QueryFilter(col, cond, val, nlc, enc);
    if (isNewRow)
    {
        queryFilters[queryFilters.length] = tmpQueryFilter;
        AddNewFilterRow();
    }
    else
    {
        queryFilters[rowNumber] = tmpQueryFilter;
        EditFilterRow(rowNumber);
    }
    HidePopups_AddEditFilterCondition();
}

function AddNewFilterRow()
{
    thisFilterCondition = queryFilters[queryFilters.length-1];
    
    btnf2 = document.createElement("input");
    btnf2.type = "button";
    btnf2.className = "btns";
    btnf2.value = "E";
    btnf2.style.cssText = "width: 16px; height: 16px;";
    btnf2.id = "btnedfi";
    btnf2.setAttribute("name", "btnedfi");
    btnf2.setAttribute("title", "Click here to edit this filter condition");
        
    bd = document.createElement("input");
    bd.type = "button";
    bd.className = "btns";
    bd.value = "X";
    bd.style.cssText = "width: 16px; height: 16px;";
    bd.id = "delfil";
    bd.setAttribute("name", "delfil");
    bd.setAttribute("title", "Click here to delete this filter condition");
    if (isIE)
    {
        btnf2.onclick = function () { btnEditFilterRow_OnClick() };
        bd.onclick = function () { btnDeleteFilterRow_OnClick() };        

        tr = filtersTable.insertRow();
        tr.id = "fir";
        tr.setAttribute("name", "fir");

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(btnf2);

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(bd);

		td = tr.insertCell();
        td.id = "fitd1";
        td.setAttribute("name", "fitd1");
		td.vAlign = "top";
		td.align = "left";
		td.className = "fes";
		td.innerText = thisFilterCondition.filterSyntax;

		td = tr.insertCell();
        td.id = "fitd2";
        td.setAttribute("name", "fitd2");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerHTML = thisFilterCondition.connector;
    }
    else
    {
        btnf2.setAttribute("onClick", "btnEditFilterRow_OnClick(this)");
        bd.setAttribute("onclick", "btnDeleteFilterRow_OnClick(this)");
        
		tr = document.createElement("tr");
        tr.id = "fir";
        tr.setAttribute("name", "fir");

		td = document.createElement("td");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(btnf2);

		td = document.createElement("td");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(bd);

		td = document.createElement("td");
		tr.appendChild(td);
        td.id = "fitd1";
        td.setAttribute("name", "fitd1");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerText = thisFilterCondition.filterSyntax;

		td = document.createElement("td");
		tr.appendChild(td);
        td.id = "fitd2";
        td.setAttribute("name", "fitd2");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerHTML = thisFilterCondition.connector;
		
		filtersTable.appendChild(tr);	
		
    }  
    return false;
}


function EditFilterRow(rowNum)
{
    thisFilterCondition = queryFilters[rowNum];
    document.getElementsByName("fitd1")[rowNum].innerText = thisFilterCondition.filterSyntax;
    document.getElementsByName("fitd2")[rowNum].innerText = thisFilterCondition.connector;
    return false;
}

function btncancelaefi_OnClick()
{
    HidePopups_AddEditFilterCondition();
    return false;
}

function btnfncaefi_OnClick(obj)
{
    columnNamesList = columnNamesListForFilters;
    ShowPopups_AddFunction("ddlcolaefi", obj, "btnfncaefi", 0);
}

function btnEditFilterRow_OnClick(obj)
{
    rowIndex = -1;
    if (isIE)
    {
        rowIndex = event.srcElement.parentElement.parentElement.rowIndex - 1;
    }
    else
    {
        for (var i=0; i<document.getElementsByName("btnedfi").length; i++)
        {
            if (document.getElementsByName("btnedfi")[i] == obj)
            {
                rowIndex = i;
                break;
            }
        }
    }
    if (rowIndex > -1)
    {
        thisFilterCondition = queryFilters[rowIndex];
        col = thisFilterCondition.columnName;
        cond = thisFilterCondition.condition;
        val = thisFilterCondition.value;
        enc = thisFilterCondition.enclosure;
        con = thisFilterCondition.connector;
        var tmpColumnNamesListForFilters = new Array();
        for (var i=0; i<columnNamesListForFilters.length; i++)
        {
            if (col.toUpperCase().indexOf(columnNamesListForFilters[i].toUpperCase()) >= 0)
            {
                tmpColumnNamesListForFilters[tmpColumnNamesListForFilters.length] = col;
            }
            else
            {
                tmpColumnNamesListForFilters[tmpColumnNamesListForFilters.length] = columnNamesListForFilters[i];
            }    
        }
        FillDropDownList(ddlFilterCol, col, tmpColumnNamesListForFilters, tmpColumnNamesListForFilters, true);
        ddlFilterCondi.value = cond;
        tbFilterValue.value = val;
        ddlFilterNlc.value = con;
        if (enc != "")
        {
            for (var i=0; i<rbFilterEnc.length; i++)
            {
                if (rbFilterEnc[i].value == enc)
                {
                    rbFilterEnc[i].checked = true;
                    break;
                }
            }
        }
        hidFilterRowNum.value = rowIndex;
        ShowPopups_AddEditFilterCondition();
    }    
    return false;
}

function btnDeleteFilterRow_OnClick(obj)
{
    if (isIE)
    {
        rowIndex = event.srcElement.parentElement.parentElement.rowIndex - 1;
        filtersTable.deleteRow(rowIndex+1);
    }
    else
    {
        for (var i=0; i<document.getElementsByName("delfil").length; i++)
        {
            if (document.getElementsByName("delfil")[i] == obj)
            {
                rowIndex = i;
                filtersTable.removeChild(document.getElementsByName("fir")[i]);
                break;
            }
        }
    }
    queryFilters = DeleteArrayElement(queryFilters, rowIndex);
}

function DeleteAllFilterRows()
{
    numFilterRows = document.getElementsByName("fir").length;
    for (var i=numFilterRows-1; i>=0; i--)
    {
        if (isIE)
        {
            filtersTable.deleteRow(i+1);  
        }
        else
        {
            filtersTable.removeChild(document.getElementsByName("fir")[i]);
        }
    }
    queryFilters = new Array();
}

function DeleteFilterRowsContainingTable(tableAlias)
{
    tableAlias += ".";
    if (sqlQueryType != "S")
    {
        dbObject = FindDatabaseObjectByAlias(tableAlias);
        if (dbObject != null)
        {
            tableAlias = dbObject.displayName;
        }
    }
    //tableName = tableName + ".";
    for (var i=queryFilters.length-1; i>=0; i--)
    {
        if (queryFilters[i].columnName.toUpperCase().indexOf(tableAlias.toUpperCase()) >= 0)
        {
            queryFilters = DeleteArrayElement(queryFilters, i);
            if (isIE)
            {
                filtersTable.deleteRow(i+1);  
            }
            else
            {
                filtersTable.removeChild(document.getElementsByName("fir")[i]);
            }
        }
    }
}
