﻿var columnToView = null;
var parentWindow = window.opener;
function btnAddMoreTables_OnClick()
{
    if (sqlQueryType != "S" && databaseObjects.length > 0)
    {
        alert("A maximum of one (1) database object can be selected for the chosen query type");
    }
    else//only one object type for update & delete query type.
    {
        ShowPopups_AddTables(objAddTables);
        CenterIt(objAddTables);
        TabClicked(objTabT);
    }
    return false;    
}

function DrawAddedTables(tablesList)
{
    var tableObj = document.getElementsByName("tblSelectedTables")[0];
    for (var i=0; i<tablesList.length; i++)
    {
        cb = document.createElement("input");
        cb.type = "checkbox";
        cb.id = "cbTableName";
        cb.setAttribute("name", "cbTableName");
        cb.style.cssText = "width: 10px; height: 10px;";
        cb.value = tablesList[i].alias;
        if (isIE)
        {
            cb.onclick = function() { cbTableName_OnClick(); }
            
            tr = tableObj.insertRow();
            tr.id = "str";
            tr.setAttribute("name", "str");

		    td = tr.insertCell();
		    td.vAlign = "middle";
		    td.align = "left";
		    td.className = "fes";
		    td.width = "5%";
		    td.appendChild(cb);

		    td = tr.insertCell();
		    td.vAlign = "middle";
		    td.align = "left";
		    td.className = "fes";
		    td.width = "95%";
		    td.innerText = tablesList[i].displayName + " (" + tablesList[i].alias + ")";
        }
        else
        {
            cb.setAttribute("onClick", "cbTableName_OnClick(this)");
            
            tr = document.createElement("tr");
            tr.id = "str";
            tr.setAttribute("name", "str");

            td = document.createElement("td");
            td.vAlign = "top";
            td.align = "center";
            td.className = "fes";
            td.appendChild(cb);
            tr.appendChild(td);

            td = document.createElement("td");
            td.vAlign = "top";
            td.align = "center";
            td.className = "fes";
            td.innerText = tablesList[i].displayName + " (" + tablesList[i].alias + ")";
            tr.appendChild(td);

    		tableObj.appendChild(tr);	
        }
    }
}

function cbTableName_OnClick(obj)
{
    if (isIE)
    {
        obj = event.srcElement;
        tableRowIndex = obj.parentElement.parentElement.rowIndex;
    }
    else
    {
        for (var i=0; i<document.getElementsByName("cbTableName").length; i++)
        {
            if (document.getElementsByName("cbTableName")[i] == obj)
            {
                tableRowIndex = i;
                break
            }
        }
    }
    tblName = obj.value;
    if (obj.checked)
    {
        ViewColumns();
    }
    if (! obj.checked)
    {
        //alert("Here: " + tblName + " : " + tableRowIndex);
        RemoveColumns(tblName);
    }
}

function RemoveColumns(tableAlias)
{
    //tableAlias = databaseObjects[tableIndex].alias;
    columnRowsContainingTable = document.getElementsByName("rr." + tableAlias + ".");
    tableObj = document.getElementsByName("tblSelectedTablesColumns")[0];
    if (isIE)
    {
        numRows = tableObj.rows.length;
        for (var i=numRows-1; i>=0; i--)
        {
            if (tableObj.rows[i].id == "rr." + tableAlias + ".")
            {
                tableObj.deleteRow(i);
            }
        }
    }
    else
    {
        for (var i=columnRowsContainingTable.length-1; i>=0; i--)
        {
            tableObj.removeChild(columnRowsContainingTable[i]);
        }
    }
    
    document.getElementsByName("btnViewColumnDetails")[0].disabled = true;
    for (var i=0; i<document.getElementsByName("rbColumName").length; i++)
    {
        if (document.getElementsByName("rbColumName")[i].checked == true)
        {
            document.getElementsByName("btnViewColumnDetails")[0].disabled = false;
            break;
        }
    }
    return false;
}

function ViewColumns()
{
    var columnsTableCleared = false;
    for (var i=0; i<document.getElementsByName("cbTableName").length; i++)
    {
        cbTable = document.getElementsByName("cbTableName")[i];
        if (cbTable.checked)
        {
            tableAlias = cbTable.value;
            tableType = databaseObjects[i].type;
            if (! columnsTableCleared)
            {
                ClearColumnsTable();
                columnsTableCleared = true;
            }
            columnStart = -1;
            columnEnd = -1;
            for (var j=0; j<dbColumns.length; j++)
            {
                fullColumnName = dbColumns[j].columnDisplayName.toUpperCase();
                if (fullColumnName.indexOf(tableAlias.toUpperCase()+".") == 0)
                {
                    if (fullColumnName.indexOf("*") < 0)
                    {
                        columnStart = j;
                        break;
                    }
                }
            }
            if (dbColumns[dbColumns.length-1].columnDisplayName.toUpperCase().indexOf(tableAlias.toUpperCase()+".") == 0)
            {
                columnEnd = dbColumns.length;
            }
            else
            {
                for (var j=columnStart; j<dbColumns.length; j++)
                {
                    fullColumnName = dbColumns[j].columnDisplayName;
                    if (fullColumnName.indexOf(tableAlias+".") != 0)
                    {
                        columnEnd = j;
                        break;
                    }
                }
            }
            tableObj = document.getElementsByName("tblSelectedTablesColumns")[0];
            
            for (var j=columnStart; j<columnEnd; j++)
            {
                rb = document.createElement("input");
                rb.type = "radio";
                rb.id = "rbColumName";
                rb.setAttribute("name", "rbColumName");
                rb.style.cssText = "width: 10px; height: 10px;";
                rb.value = dbColumns[j].id + "+" + dbColumns[j].name + "+" + dbColumns[j].parentId + "+" + dbColumns[j].parentType;
                if (tableType != "1")
                {
                }
                if (isIE)
                {
                    rb.onclick = function() { rbColumName_OnClick() };
                    
                    tr = tableObj.insertRow();
                    tr.id = "rr." + tableAlias + ".";
                    tr.setAttribute("name", "rr." + tableAlias + ".");
		            td = tr.insertCell();
		            td.vAlign = "middle";
		            td.align = "left";
		            td.className = "fes";
		            td.width = "5%";
		            td.appendChild(rb);

		            td = tr.insertCell();
		            td.vAlign = "middle";
		            td.align = "left";
		            td.className = "fes";
		            td.width = "95%";
		            td.innerText = dbColumns[j].columnDisplayName;
                }
                else
                {
                    rb.setAttribute("onClick", "rbColumName_OnClick(this)");

		            tr = document.createElement("tr");
                    tr.id = "rr." + tableAlias + ".";
                    tr.setAttribute("name", "rr." + tableAlias + ".");

		            td = document.createElement("td");
		            td.vAlign = "top";
		            td.align = "center";
		            td.className = "fes";
		            td.appendChild(rb);
		            tr.appendChild(td);

		            td = document.createElement("td");
		            td.vAlign = "top";
		            td.align = "center";
		            td.className = "fes";
		            td.innerText = dbColumns[j].columnDisplayName;
		            tr.appendChild(td);
		
            		tableObj.appendChild(tr);	
                }
            }
        }
    }
}

function ClearColumnsTable()
{
    tableObj = document.getElementsByName("tblSelectedTablesColumns")[0];
    while (true)
    {
        if (isIE)
        {
            if (tableObj.rows.length <= 0) { break; }
            tableObj.deleteRow();
        }
        else
        {
            if (document.getElementsByName("stcr").length <=0) { break; }
            tableObj.removeChild(document.getElementsByName("stcr")[0]);
        }
    }
    document.getElementsByName("btnViewColumnDetails")[0].disabled = true;
    columnToView = null;
}

function rbColumName_OnClick(obj)
{
    if (isIE)
    {
        obj = event.srcElement;
    }
    columnToView = obj.value;
    document.getElementsByName("btnViewColumnDetails")[0].disabled = false;
    obj.checked = true;
}

function btnViewColumnDetails_OnClick()
{
    try
    {
        if (columnToView != null)
        {
            dataArray = columnToView.split("+");
            colId = dataArray[0];
            colNm = dataArray[1];
            parId = dataArray[2];
            parTyp = dataArray[3];
            window.opener.GetSubObject(COLUMN,colId,colNm,parId,parTyp);
        }
    }
    catch (e)
    {
        alert("Unable to display the column details: " + e.message);
    }
}


function btnRemoveAllTables_OnClick(askConfirm)
{
    deleteAllTables = true;
    if (askConfirm)
    {
        deleteAllTables = window.confirm("Are you sure you want to remove all the tables from this query?");
    }
    if (deleteAllTables)
    {
        ClearColumnsTable();
        DeleteAllGroupingRows();
        DeleteAllFilterRows();
        DeleteAllSelectRows();
        DeleteAllJoinRows();
        DeleteAllForeignKeys();
        databaseObjects = new Array();
        dbColumns = new Array();
        columnNamesListForSelect = new Array();
        columnNamesListForJoins = new Array();
        columnNamesListForFilters = new Array();
        selectedTablesObj = document.getElementsByName("tblSelectedTables")[0];
        for (var i=document.getElementsByName("cbTableName").length-1; i>=0; i--)
        {
            thisTableName = document.getElementsByName("cbTableName")[i].value;
            if (isIE)
            {
                selectedTablesObj.deleteRow(i);
            }
            else
            {
                selectedTablesObj.removeChild(document.getElementsByName("str")[i]);
            }
        }
       DeleteAllUpdateRows();
       document.getElementsByName("tbSQL")[0].value = ""
       numberDatabaseObjectsSelectedCount = 1;
    }
}

function btnRemoveTables_OnClick()
{
    var rowNumbersToDelete = new Array();
    var tableNamesToDelete = new Array();
    var tableAliasesToDelete = new Array();
    for (var i=0; i<document.getElementsByName("cbTableName").length; i++)
    {
        if (document.getElementsByName("cbTableName")[i].checked)
        {
            rowNumbersToDelete[rowNumbersToDelete.length] = i;
            tableNamesToDelete[tableNamesToDelete.length] = document.getElementsByName("cbTableName")[i].value;
            tableAliasesToDelete[tableAliasesToDelete.length] = document.getElementsByName("cbTableName")[i].value;
            RemoveColumns(document.getElementsByName("cbTableName")[i].value);
        }
    }
    if (rowNumbersToDelete.length <= 0)
    {
        alert("Please select some tables to delete");
        return false;
    }
    else
    {
       DeleteAllUpdateRows();
       rowNumbersToDelete.reverse();
       tableNamesToDelete.reverse();
       selectedTablesObj = document.getElementsByName("tblSelectedTables")[0];
       for (var kk=0; kk<rowNumbersToDelete.length; kk++)
       {
            thisTableName = tableNamesToDelete[kk];
            thisTableAlias = tableAliasesToDelete[kk];
            DeleteGroupingRowsContainingTable(thisTableAlias);
            DeleteSelectRowsContainingTable(thisTableAlias);
            DeleteFilterRowsContainingTable(thisTableAlias);
            DeleteJoinRowsContainingTable(thisTableAlias);
            DeleteForeignKeysContainingTable(thisTableAlias);
            RemoveColumns(thisTableName, kk);
            if (isIE)
            {
                selectedTablesObj.deleteRow(rowNumbersToDelete[kk]);
            }
            else
            {
                rowNum = rowNumbersToDelete[kk];
                selectedTablesObj.removeChild(document.getElementsByName("str")[rowNum]);
            }
            //first delete the columns from dbColumns
            for (var j=dbColumns.length-1; j>=0; j--)
            {
                if (dbColumns[j].tableAlias == tableAliasesToDelete[kk])
                {
                    dbColumns = DeleteArrayElement(dbColumns, j);
                }
            }
            //remove the tables from the table array
            for (var j=databaseObjects.length-1; j>=0; j--)
            {
                if (databaseObjects[j].alias == thisTableAlias)
                {
                    databaseObjects = DeleteArrayElement(databaseObjects, j);
                }
            }
            
       }
       columnNamesListForSelect = new Array();
       columnNamesListForJoins = new Array();
       columnNamesListForFilters = new Array();
       for (var i=0; i<dbColumns.length; i++)
       {
            columnNamesListForSelect[columnNamesListForSelect.length] = dbColumns[i].columnDisplayName;
            if (dbColumns[i].columnDisplayName.indexOf("*") < 0)
            {
                columnNamesListForJoins[columnNamesListForJoins.length] = dbColumns[i].columnDisplayName;
                if (sqlQueryType != "S")
                {
                    columnNamesListForFilters[columnNamesListForFilters.length] = dbColumns[dbColumns.length-1].fullColumnName;
                }
                else
                {
                    columnNamesListForFilters[columnNamesListForFilters.length] = dbColumns[dbColumns.length-1].columnDisplayName;
                }    
            }
       }
       RepopulateFilterColumnRows();
       RepopulateSelectColumnRows();
    }
}