﻿var objStoredProcDesigner = null;
var objParametersPanel = null;
var objSQLPanel = null;
var objBodyPanel = null;
var objParametersTable = null;
var objParametersTab = null;
var objBodyTab = null;
var objSQLTab = null;
var objTablePleaseWait = null;
var objCellPleaseWaitMessage = null;
var objSchema = null;
var objProcedureName = null;
var objCbEncryptedProcedure = null;
var objCbRecompileProcedure = null;
var objCbProcedureForReplication = null;
var objExecuteAs = null;
var objTbCode = null;
var objTbSQL = null;
var objAddEditParameterPanel = null;
var objParameterName = null;
var objParameterDataType = null;
var objLength = null;
var objPrecision = null;
var objScale = null;
var objIsRefCursor = null;
var objIsOutputParameter = null;
var objIsReadonly = null;
var objParameterDefaultValue = null;
var mode = "A"; 
var procedureMode = "N";

function BodyOnLoad()
{
    try
    {
        objStoredProcDesigner = document.getElementsByName("tblStoredProcedureDesigner")[0];
        objParametersTable = document.getElementsByName("tblParameters")[0];
        objParametersPanel = document.getElementsByName("pnlParameters")[0];
        objBodyPanel = document.getElementsByName("pnlBody")[0];
        objSQLPanel = document.getElementsByName("pnlSQL")[0];
        objParametersTab = document.getElementsByName("tabParameters")[0];
        objSQLTab = document.getElementsByName("tabSQL")[0];
        objBodyTab = document.getElementsByName("tabBody")[0];
        objTablePleaseWait = document.getElementsByName("tblPleaseWait")[0];
        objCellPleaseWaitMessage = document.getElementsByName("cellPleaseWaitMessage")[0];
        objSchema = document.form1.ddlSchema;
        objProcedureName = document.form1.tbProcedureName;
        objCbEncryptedProcedure = document.form1.cbEncryptedProcedure;
        objCbRecompileProcedure = document.form1.cbRecompileProcedure;
        objCbProcedureForReplication = document.form1.cbProcedureForReplication;
        objExecuteAs = document.form1.ddlExecuteAs;
        objTbCode = document.form1.tbCode;
        objTbSQL = document.form1.tbSQL;
        InitParametersPanel();
        if (parameters != null && parameters.length > 0)
        {
            for (var i=0; i<parameters.length; i++)
            {
                PaintNewParameterRow(parameters[i], i);
            }
        }
    }
    catch (e)
    {
    }
}

function ParametersTabClicked(obj)
{
    objSQLTab.className = "itabr";
    objBodyTab.className = "itabr";
    objParametersTab.className = "atabr";
    objSQLPanel.style.display = "none";
    objBodyPanel.style.display = "none";
    objParametersPanel.style.display = "block";
    return false;
}

function BodyTabClicked(obj)
{
    HideAddEditParameterPanel();
    objSQLTab.className = "itabr";
    objBodyTab.className = "atabr";
    objParametersTab.className = "itabr";
    objSQLPanel.style.display = "none";
    objBodyPanel.style.display = "block";
    objParametersPanel.style.display = "none";
    objTbCode.focus();
    return false;
}

function SQLTabClicked(obj)
{
    HideAddEditParameterPanel();
    if (ValidateProcedure())
    {
        objSQLTab.className = "atabr";
        objBodyTab.className = "itabr";
        objParametersTab.className = "itabr";
        objSQLPanel.style.display = "block";
        objBodyPanel.style.display = "none";
        objParametersPanel.style.display = "none";
        if (procedureMode == "N")
        {
            objTbSQL.value = "-- Preparing procedure create script, please wait";
        }
        else
        {
            objTbSQL.value = "-- Preparing procedure alter script, please wait";
        }
        Omega.Web.MSSQL.StoredProcedureDesigner.BuildCreateOrAlterStoredProcedureSqlStatement(parseInt(document.form1.procedureId.value, 10), trim(objSchema.value), trim(objProcedureName.value), objCbEncryptedProcedure.checked, objCbRecompileProcedure.checked, objCbProcedureForReplication.checked, trim(objExecuteAs.value), trim(objTbCode.value), parameters, BuildCreateOrAlterStoredProcedureSqlStatement_Callback);
    }
    return false;
}

function BuildCreateOrAlterStoredProcedureSqlStatement_Callback(resp)
{
    HideAddEditParameterPanel();
    objSQLTab.className = "atabr";
    objBodyTab.className = "itabr";
    objParametersTab.className = "itabr";
    objSQLPanel.style.display = "block";
    objBodyPanel.style.display = "none";
    objParametersPanel.style.display = "none";
    objTbSQL.value = resp.value;
    return false;
}

function btnTestSql_OnClick()
{
    HideAddEditParameterPanel();
    if (ValidateProcedure())
    {
        objStoredProcDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = checkSqlText;
        Omega.Web.MSSQL.StoredProcedureDesigner.ValidateSql(parseInt(document.form1.procedureId.value, 10), trim(objSchema.value), trim(objProcedureName.value), objCbEncryptedProcedure.checked, objCbRecompileProcedure.checked, objCbProcedureForReplication.checked, trim(objExecuteAs.value), trim(objTbCode.value), parameters, ValidateSql_Callback);
    }
    return false;
}

function ValidateSql_Callback(resp)
{
    alert(resp.value);
    objStoredProcDesigner.style.display = "block";
    objTablePleaseWait.style.display = "none";
}

function btnExecuteSql_OnClick()
{
    HideAddEditParameterPanel();
    if (ValidateProcedure())
    {
        objStoredProcDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = savingTableText;
        Omega.Web.MSSQL.StoredProcedureDesigner.CreateOrAlterStoredProcedure(parseInt(document.form1.procedureId.value, 10), trim(objSchema.value), trim(objProcedureName.value), objCbEncryptedProcedure.checked, objCbRecompileProcedure.checked, objCbProcedureForReplication.checked, trim(objExecuteAs.value), trim(objTbCode.value), parameters, CreateOrAlterStoredProcedure_Callback);
    }
    return false;
}

function CreateOrAlterStoredProcedure_Callback(resp)
{
    respval = resp.value;
    isError = true;
    message = "Unable to update the database";
    if (respval != null)
    {
        respvalarray = respval.split("|");
        message = respvalarray[1];
        if (respval.charAt(0) == "0")
        {
            isError = false;
        }
    }
    alert(message);
    if (isError)
    {
        objStoredProcDesigner.style.display = "block";
        objTablePleaseWait.style.display = "none";
    }
    else
    {
        window.opener.StoredProcedureDesignerComplete(procedureMode, document.form1.procedureId.value, trim(objProcedureName.value));
        self.close();
    }
}

function btnNewParameter_OnClick()
{
    mode = "A";
    ShowAddEditParameterPanel();
    objParameterName.focus();
    return false;
}

function ValidateProcedure()
{
    objProcedureName.value = trim(objProcedureName.value);
    objTbCode.value = trim(objTbCode.value);
    spid = document.form1.procedureId.value;
    if (parseInt(spid, 10) > 0)
    {
        procedureMode = "E";
    }
    if (objProcedureName.value == "")
    {
        alert("Procedure name is required");
        objProcedureName.focus();
        return false;
    }    
    if (objTbCode.value == "")
    {
        alert("Procedure body is required");
        BodyTabClicked(null);
        objTbCode.focus();
        return false;
    }    
    return true;
}