﻿var rowIndex = -1;
var columnToBeEdited = null;
function InitColumnsPanel()
{
    objAddEditColumnPanel = document.getElementsByName("pnlAddEditColumn")[0];
    objColumnName = document.form1.tbColumnName;
    objColumnDataType = document.form1.ddlColumnDataType;
    objLength = document.form1.tbLength;
    objPrecision = document.form1.tbPrecision;
    objScale = document.form1.tbScale;
    objIsPrimaryKey = document.form1.cbPrimaryKey;
    objIsIdentityCol = document.form1.cbIdentityCol;
    objIdentitySeed = document.form1.tbIdentitySeed;
    objIdentityIncrement = document.form1.tbIdentityIncrement;
    objNullAllowed = document.form1.cbNullAllowed;
    objIsRowGuid = document.form1.cbRowGuid;
    objTbDefault = document.form1.tbDefault;
    objDdlDefault = document.form1.ddlDefault;
    objDdlRule = document.form1.ddlRule;
    objTbComputedColumn = document.form1.tbComputedColumn;
    objCollation = document.form1.ddlCollation;
}

function EditColumn(columnIndex)
{
    try
    {
        InitializeAddEditColumnPanel();
        rowIndex = columnIndex;
        columnToBeEdited = columns[columnIndex];
        mode = "E";
        objColumnName.value = columnToBeEdited.name;
        objColumnDataType.value = columnToBeEdited.dataType;
        ddlColumnDataType_OnChange(objColumnDataType);
        objLength.value = columnToBeEdited.length;
        objPrecision.value = columnToBeEdited.precision;
        objScale.value = columnToBeEdited.scale;
        objIsPrimaryKey.checked = columnToBeEdited.isPrimaryKey;
        objIsIdentityCol.checked = columnToBeEdited.isIdentityColumn;
        objIdentitySeed.value = columnToBeEdited.identitySeed;
        objIdentityIncrement.value = columnToBeEdited.identityIncrement;
        objNullAllowed.checked = columnToBeEdited.isNullAllowed;
        objIsRowGuid.checked = columnToBeEdited.isRowGuid;
        objTbDefault.value = columnToBeEdited.defaultValue;
        objDdlRule.value = columnToBeEdited.rule;
        objTbComputedColumn.value = columnToBeEdited.formula;
        objCollation.value = columnToBeEdited.collation;
        objAddEditColumnPanel.style.display = "block";
        objColumnName.select();
        CenterIt(objAddEditColumnPanel);
    }
    catch (e)
    {
    }
}

function ShowAddEditColumnPanel()
{
    InitializeAddEditColumnPanel();
    objAddEditColumnPanel.style.display = "block";
    CenterIt(objAddEditColumnPanel);
}

function HideAddEditColumnPanel()
{
    objAddEditColumnPanel.style.display = "none";
    columnToBeEdited = null;
    rowIndex = -1;
    mode = "A";
}

function InitializeAddEditColumnPanel()
{
    columnToBeEdited = null;
    objColumnName.value = "";
    objColumnDataType.selectedIndex = 0;
    objLength.className = "tfsd";
    objLength.readOnly = true;
    objLength.value = "";
    objPrecision.className = "tfsd";
    objPrecision.readOnly = true;
    objPrecision.value = "";
    objScale.className = "tfsd";
    objScale.readOnly = true;
    objScale.value = "";
    objIsPrimaryKey.disabled = false;
    objIsPrimaryKey.checked = false;
    objIsIdentityCol.disabled = false;
    objIsIdentityCol.checked = false;
    objIdentitySeed.className = "tfsd";
    objIdentitySeed.readOnly = true;
    objIdentitySeed.value = "";
    objIdentityIncrement.className = "tfsd";
    objIdentityIncrement.readOnly = true;
    objIdentityIncrement.value = "";
    objNullAllowed.disabled = false;
    objNullAllowed.checked = true;
    objIsRowGuid.disabled = false;
    objIsRowGuid.checked = false;
    objTbDefault.value = "";
    objDdlDefault.selectedIndex = 0;
    objDdlRule.selectedIndex = 0;
    objTbComputedColumn.className = "tfs";
    objTbComputedColumn.readOnly = false;
    objTbComputedColumn.value = "";
    objCollation.selectedIndex = 0;
    objCollation.disabled = true;
}

function ddlColumnDataType_OnChange(obj)
{
    dataTypeValue = trim(obj.value.toLowerCase());
    objLength.className = "tfsd";
    objLength.readOnly = true;
    objLength.value = "";
    objPrecision.className = "tfsd";
    objPrecision.readOnly = true;
    objPrecision.value = "";
    objScale.className = "tfsd";
    objScale.readOnly = true;
    objScale.value = "";
    objIsPrimaryKey.checked = false;
    objIsIdentityCol.checked = false;
    objIsIdentityCol.disabled = true;
    objIdentitySeed.className = "tfsd";
    objIdentitySeed.readOnly = true;
    objIdentitySeed.value = "";
    objIdentityIncrement.className = "tfsd";
    objIdentityIncrement.readOnly = true;
    objIdentityIncrement.value = "";
    objIsRowGuid.checked = false;
    objIsRowGuid.disabled = true;
    objNullAllowed.disabled = false;
    objCollation.selectedIndex = 0;
    objCollation.disabled = true;
    objTbComputedColumn.className = "tfs";
    objTbComputedColumn.readOnly = false;
    var selectedDataType = null;
    for (var i=0; i<dataTypes.length; i++)
    {
        if (dataTypes[i].Name.toLowerCase() == dataTypeValue)
        {
            selectedDataType = dataTypes[i];
            break;
        }
    }    
    if (selectedDataType != null)
    {
        var isOriginalDataType = false;            
        objLength.value = selectedDataType.DefaultLength;
        if (selectedDataType.IsLengthEditable)
        {
            objLength.className = "tfs";
            objLength.readOnly = false;
        }
        else
        {
            objLength.className = "tfsd";
            objLength.readOnly = true;
        }
        objPrecision.value = selectedDataType.DefaultPrecision;
        if (selectedDataType.IsPrecisionEditable)
        {
            objPrecision.className = "tfs";
            objPrecision.readOnly = false;
        }
        else
        {
            objPrecision.className = "tfsd";
            objPrecision.readOnly = true;
        }
        objScale.value = selectedDataType.DefaultScale;
        if (selectedDataType.IsScaleEditable)
        {
            objScale.className = "tfs";
            objScale.readOnly = false;
        }
        else
        {
            objScale.className = "tfsd";
            objScale.readOnly = true;
        }
        if (selectedDataType.CanBeIdentityColumn)
        {
            objIsIdentityCol.disabled = false;
        }
        if (selectedDataType.CanBeRowGUIDColumn)
        {
            objIsRowGuid.disabled = false;
        }
        if (selectedDataType.IsCollationApplicable)
        {
            objCollation.disabled = false;
        }

        if (mode == "E")
        {
            if (selectedDataType.Name.toLowerCase() == columnToBeEdited.dataType.toLowerCase())
            {
                isOriginalDataType = true;  
            }
        }

        if (isOriginalDataType)
        {
            objLength.value = columnToBeEdited.length;
            objPrecision.value = columnToBeEdited.precision;
            objScale.value = columnToBeEdited.scale;
            objIsIdentityCol.checked = columnToBeEdited.isIdentityColumn;
            objIdentitySeed.value = columnToBeEdited.identitySeed;
            objIdentityIncrement.value = columnToBeEdited.identityIncrement;
            objCollation.value = columnToBeEdited.collation;
            objIsPrimaryKey.checked = columnToBeEdited.isPrimaryKey;
            objNullAllowed.checked = columnToBeEdited.isNullAllowed;
            if (columnToBeEdited.isPrimaryKey)
            {
                objNullAllowed.checked = false;
                objNullAllowed.disabled = true;
            }    
        }
        else
        {
            objLength.value = selectedDataType.DefaultLength;
            objPrecision.value = selectedDataType.DefaultPrecision;
            objScale.value = selectedDataType.DefaultScale;
        }
        if (mode == "E" && columnToBeEdited.id > 0)
        {
            objIsIdentityCol.disabled = true;
            objIdentitySeed.readOnly = true;
            objIdentitySeed.className = "tfsd";
            objIdentityIncrement.readOnly = true;
            objIdentityIncrement.className = "tfsd";
            objTbComputedColumn.className = "tfsd";
            objTbComputedColumn.readOnly = true;
        }

    }
}

function cbPrimaryKey_OnClick(obj)
{
    if (obj.checked)
    {
        objNullAllowed.checked = false;
        objNullAllowed.disabled = true;    
    }
    else
    {
        objNullAllowed.disabled = false;    
    }
    
}

function cbIdentityCol_OnClick(obj)
{
    if (obj.checked)
    {
        var existingIdentityColumn = false;
        var columnNameWithIdentity = "";
        for (var i=0; i<columns.length; i++)
        {
            if ((columns[i].isIdentityColumn) && (i != rowIndex) && (! columns[i].isColumnDeleted))
            {
                existingIdentityColumn = true;
                columnNameWithIdentity = columns[i].name;
                break;
            }
        }
        if (existingIdentityColumn)
        {
            alert("There can be only one identity column in a table. Column \"" + columnNameWithIdentity + "\" is currently the identity column");
            obj.checked = false;
            objIdentitySeed.className = "tfsd";
            objIdentitySeed.readOnly = true;
            objIdentityIncrement.className = "tfsd";
            objIdentityIncrement.readOnly = true;
            return false;
        }
        objIdentitySeed.className = "tfs";
        objIdentitySeed.readOnly = false;
        objIdentityIncrement.className = "tfs";
        objIdentityIncrement.readOnly = false;
        if (objIdentitySeed.value == "") { objIdentitySeed.value = "1"; }
        if (objIdentityIncrement.value == "") { objIdentityIncrement.value = "1"; }
    }
    else
    {
        objIdentitySeed.className = "tfsd";
        objIdentitySeed.readOnly = true;
        objIdentityIncrement.className = "tfsd";
        objIdentityIncrement.readOnly = true;
    }
    return false;
}

function cbRowGuid_OnClick(obj)
{

}

function ddlDefault_OnChange(obj)
{
    objTbDefault.value = trim(objTbDefault.value);
    var proceed = true;
    if (objTbDefault.value != "")
    {
        proceed = window.confirm("Change the value of existing default value for column?");
    }
    if (proceed)
    {
        objTbDefault.value = trim(obj.value);
    }
}

function ddlRule_OnChange(obj)
{
}

function btnNewColumn_OnClick()
{
    mode = "A";
    ShowAddEditColumnPanel();
    objColumnName.focus();
    return false;
}

function btnSaveColumn_OnClick()
{
    if (ValidateColumn())
    {
        if (mode == "A")
        {
           btnNewColumn_OnClick(); 
        }
        else
        {
            btnCancelColumn_OnClick();
        }    
    }
    return false;
}

function btnCancelColumn_OnClick()
{
    HideAddEditColumnPanel();
    return false;
}

function ValidateColumn()
{
    objColumnName.value = trim(objColumnName.value);
    objColumnDataType.value = trim(objColumnDataType.value);
    objLength.value = trim(objLength.value);
    objPrecision.value = trim(objPrecision.value);
    objScale.value = trim(objScale.value);
    objIdentitySeed.value = trim(objIdentitySeed.value);
    objIdentityIncrement.value = trim(objIdentityIncrement.value);
    objTbDefault.value = trim(objTbDefault.value);
    objDdlRule.value = trim(objDdlRule.value);
    dataTypeText = "";
    if (objColumnName.value == "") 
    { 
        alert("Column name is required.");
        objColumnName.focus();
        return false;
    }    
    //Check for valid column name
    //First character can either be an underscore (_) or a letter.
    firstChar = objColumnName.value.charAt(0).toLowerCase();
    if (! (firstChar == "_" || (firstChar >= 'a' && firstChar <= 'z')))
    {
        alert("Invalid column name. Column name must begin with an underscore (_) or a letter (a-z OR A-Z)");
        objColumnName.select();
        return false;
    }
    //Check for duplicate column name
    for (var i=0; i<columns.length; i++)
    {
        if ( (! columns[i].isColumnDeleted) && (columns[i].name.toLowerCase() == objColumnName.value.toLowerCase()) )
        {
            if (i != rowIndex)
            {
                alert("Duplicate column name found. Column names must be unique in a table");
                objColumnName.select();
                return false;
            }
        }
    }
    if (objColumnDataType.value == "") 
    { 
        alert("Column data type is required.");
        objColumnDataType.focus();
        return false;
    }    
    var selectedDataType = null;
    for (var i=0; i<dataTypes.length; i++)
    {
        if (dataTypes[i].Name.toLowerCase() == objColumnDataType.value.toLowerCase())
        {
            selectedDataType = dataTypes[i];
            break;
        }
    }    
    if (selectedDataType != null)
    {
        if (selectedDataType.IsLengthEditable)
        {
            minLength = selectedDataType.MinimumLength;
            maxLength = selectedDataType.MaximumLength;
            if (! CheckInteger(objLength, minLength, maxLength))
            {
                objLength.select();
                return false;
            }
        }
        if (selectedDataType.IsPrecisionEditable)
        {
            minPrecision = selectedDataType.MinimumPrecision;
            maxPrecision = selectedDataType.MaximumPrecision;
            if (! CheckInteger(objPrecision, minPrecision, maxPrecision))
            {
                objPrecision.select();
                return false;
            }
        }
        if (selectedDataType.IsScaleEditable)
        {
            minScale = selectedDataType.MinimumScale;
            maxScale = selectedDataType.MaximumScale;
            if (! CheckInteger(objScale, minScale, maxScale))
            {
                objScale.select();
                return false;
            }
        }
        if (! selectedDataType.IsCollationApplicable)
        {
            objCollation.selectedIndex = 0;
        }
        if (selectedDataType.IsPrecisionEditable && selectedDataType.IsScaleEditable)
        {
            if (objPrecision.value != "" && objScale.value != "")
            {
                if (parseInt(objPrecision.value, 10) <= parseInt(objScale.value, 10))
                {
                    alert("Precision value should be greater than scale value");
                    objScale.select();
                    return false;
                }
            }
        }
        dataTypeText = selectedDataType.Format;
        dataTypeText = dataTypeText.replace("$Name$", selectedDataType.Name);
        dataTypeText = dataTypeText.replace("$Length$", objLength.value);
        dataTypeText = dataTypeText.replace("$Precision$", objPrecision.value);
        dataTypeText = dataTypeText.replace("$Scale$", objScale.value);
    }
    if (objIsIdentityCol.checked)
    {
        if (! isInteger(objIdentitySeed.value, true, false))
        {
            alert("Please enter a valid value for indetity seed");
            objIdentitySeed.select();
            return false;
        }
        if (! isInteger(objIdentityIncrement.value, false, false))
        {
            alert("Please enter a valid value for indetity increment");
            objIdentityIncrement.select();
            return false;
        }
    }
    else
    {
       objIdentitySeed.value = "";
       objIdentityIncrement.value = ""; 
    }
    thisDefault = trim(objTbDefault.value);
    isDefaultAFunction = false;
    isDefaultSystemDefault = false;
    if (thisDefault != "")
    {
        isDefaultSystemDefault = IsDefaultSystemDefault(thisDefault);
    }
    if (! (thisDefault == "" || isDefaultSystemDefault))
    {
        retValue = Omega.Web.MSSQL.TableDesigner.IsSQLFunction(thisDefault);        
        if (retValue.value == "Y")
        {
            isDefaultAFunction = true;
        }
    }
    if (mode == "A")
    {
        var tc = new TableColumn(-1, objColumnName.value, objColumnDataType.value, dataTypeText, objLength.value, objPrecision.value, objScale.value, objIsPrimaryKey.checked, "", objIsIdentityCol.checked, objIdentitySeed.value, objIdentityIncrement.value, objNullAllowed.checked, objIsRowGuid.checked, thisDefault, "N", thisDefault, trim(objDdlRule.value), trim(objTbComputedColumn.value), trim(objCollation.value), "");
        tc.isDefaultAFunction = isDefaultAFunction;
        tc.isDefaultSystemDefault = isDefaultSystemDefault;
        columns[columns.length] = tc;
        PaintNewColumnRow(tc, columns.length-1);
    }
    else if (mode == "E")
    {
        var tc = new TableColumn(columnToBeEdited.id, objColumnName.value, objColumnDataType.value, dataTypeText, objLength.value, objPrecision.value, objScale.value, objIsPrimaryKey.checked, columnToBeEdited.primaryKeyName, objIsIdentityCol.checked, objIdentitySeed.value, objIdentityIncrement.value, objNullAllowed.checked, objIsRowGuid.checked, trim(objTbDefault.value), columnToBeEdited.isAutoDefaultConstraint, columnToBeEdited.defaultName, trim(objDdlRule.value), trim(objTbComputedColumn.value), trim(objCollation.value), columnToBeEdited.columnConstraints);
        tc.isDefaultAFunction = isDefaultAFunction;
        tc.isDefaultSystemDefault = isDefaultSystemDefault;
        columns[rowIndex] = tc;
        PaintEditColumnRow(tc, rowIndex);
    }
    return true;
}

function PaintEditColumnRow(editedColumn, rowIndex)
{
    if (isIE)
    {
        tr = document.getElementById("cor_" + rowIndex);
        //Primary Key
        td = tr.cells(0);
        td.innerHTML = editedColumn.isPrimaryKey ? pkText : "&nbsp;";
        //Column Name;
        td = tr.cells(1);
        td.align = "left";
        td.innerHTML = editedColumn.name;
        //Column Data Type;
        td = tr.cells(2);
        td.align = "left";
        td.innerHTML = editedColumn.dataTypeText;
        //Nulls Allowed
        td = tr.cells(3);
        td.innerHTML = editedColumn.isNullAllowed ? trueText : "&nbsp;";
        //Is Identity Column
        td = tr.cells(4);
        td.innerHTML = editedColumn.isIdentityColumn ? trueText : "&nbsp;";
        if (editedColumn.isIdentityColumn)
        {
            //identity seed
            td = tr.cells(5);
            td.innerHTML = editedColumn.identitySeed;

            //identity increment
            td = tr.cells(6);
            td.innerHTML = editedColumn.identityIncrement;
        }
        else
        {
            //identity seed
            td = tr.cells(5);
            td.innerHTML = "&nbsp;";

            //identity increment
            td = tr.cells(6);
            td.innerHTML = "&nbsp;";
        }
        //Is RowGUID Column
        td = tr.cells(7);
        td.innerHTML = editedColumn.isRowGuid ? trueText : "&nbsp;";
    }
    else
    {
    }
}

function PaintNewColumnRow(newColumn, thisColumnIndex)
{
    if (isIE)
    {
        tr = objColumnsTable.insertRow();
        //thisColumnIndex = columns.length - 1;
        rowid = "cor_" + thisColumnIndex;
        tr.id = rowid;
        tr.setAttribute("name", rowid);
        //Primary Key
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = newColumn.isPrimaryKey ? pkText : "&nbsp;";
        //Column Name;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newColumn.name;
        //Column Data Type;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newColumn.dataTypeText;
        //Nulls Allowed
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = newColumn.isNullAllowed ? trueText : "&nbsp;";
        //Is Identity Column
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = newColumn.isIdentityColumn ? trueText : "&nbsp;";
        if (newColumn.isIdentityColumn)
        {
            //identity seed
            td = tr.insertCell();
            td.className = "cdat";
            td.innerHTML = newColumn.identitySeed;

            //identity increment
            td = tr.insertCell();
            td.className = "cdat";
            td.innerHTML = newColumn.identityIncrement;
        }
        else
        {
            //identity seed
            td = tr.insertCell();
            td.className = "cdat";
            td.innerHTML = "&nbsp;";

            //identity increment
            td = tr.insertCell();
            td.className = "cdat";
            td.innerHTML = "&nbsp;";
        }
        //Is RowGUID Column
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = newColumn.isRowGuid ? trueText : "&nbsp;";
        //Edit & Delete
        editHTML = "<a href='#' onClick='EditColumn(" + thisColumnIndex + ")' title='Edit Column'>" + editText + "</a>";
        deleteHTML = "<a href='#' onClick='DeleteColumn(" + thisColumnIndex + ")' title='Delete Column'>" + deleteText + "</a>";
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = editHTML + "&nbsp;&nbsp;" + deleteHTML;
    }
}    

function DeleteColumn(columnIndex)
{
    thisColumn = columns[columnIndex];
    var confirmDelete = true;
    if (thisColumn.id >= 0)
    {
        confirmDelete = window.confirm("Are you sure you want to delete this column? Deleting a column will delete all the objects dependent on it.");
    }
    if (confirmDelete)
    {
        for (var i=0; i<indexes.length; i++)
        {
            indexColumns = indexes[i].indexColumns;
            if (indexColumns != null)
            {
                var indexOfDeletedColumn = -1;
                var numColumnsInIndex = indexColumns.length;
                for (var j=0; j<numColumnsInIndex; j++)
                {
                    if (indexColumns[j].columnId == thisColumn.id)
                    {
                        indexOfDeletedColumn = j;
                        break;
                    }
                }
                if (indexOfDeletedColumn >= 0)
                {
                    if (numColumnsInIndex == 1)
                    {
                        indexes[i].isIndexAltered = true;
                        indexes[i].shouldIndexBeDeleted = true;
                        indexes[i].indexColumns = null;
                    }
                    else
                    {
                        indexes[i].isIndexAltered = true;
                        if (indexOfDeletedColumn == 0)
                        {
                            tmp = indexes[i].indexColumns.shift();
                        }
                        else if (indexOfDeletedColumn == numColumnsInIndex-1)
                        {
                            tmp = indexes[i].indexColumns.pop();
                        }
                        else
                        {
                            tmp1 = indexes[i].indexColumns.slice(0, indexOfDeletedColumn);
                            tmp2 = indexes[i].indexColumns.slice(indexOfDeletedColumn);
                            indexes[i].indexColumns = tmp1.join(tmp2);
                        }
                    }
                }
            }
        }
        thisColumn.isColumnDeleted = true;
        columns[columnIndex] = thisColumn;
        rowObjId = "cor_" + columnIndex;
        rowObj = document.getElementsByName(rowObjId)[0];
		if (isIE) { ri = rowObj.rowIndex; objColumnsTable.deleteRow(ri); }
		else { deletedRow = objColumnsTable.removeChild(rowObj); }
    }
}
