﻿var parameterRowIndex = -1;
var parameterToBeEdited = null;
var parameterMode = "A";
function InitParametersPanel()
{
    objAddEditParameterPanel = document.getElementsByName("pnlAddEditParameter")[0];
    objParameterName = document.form1.tbParameterName;
    objParameterDataType = document.form1.ddlParameterDataType;
    objParameterLength = document.form1.tbParameterLength;
    objParameterPrecision = document.form1.tbParameterPrecision;
    objParameterScale = document.form1.tbParameterScale;
    objParameterIsReadonly = document.form1.cbIsParameterReadonly;
    objParameterDefaultValue = document.form1.tbParameterDefault;
}

function btnNewParameter_OnClick()
{
    parameterMode = "A";
    ShowAddEditParameterPanel();
    objParameterName.focus();
    return false;
}

function ShowAddEditParameterPanel()
{
    InitializeAddEditParameterPanel();
    objAddEditParameterPanel.style.display = "block";
    CenterIt(objAddEditParameterPanel);
}

function HideAddEditParameterPanel()
{
    objAddEditParameterPanel.style.display = "none";
    parameterToBeEdited = null;
    parameterRowIndex = -1;
    parameterMode = "A";
}


function InitializeAddEditParameterPanel()
{
    parameterToBeEdited = null;
    objParameterName.value = "";
    objParameterDataType.selectedIndex = 0;
    objParameterLength.className = "tfsd";
    objParameterLength.readOnly = true;
    objParameterLength.value = "";
    objParameterPrecision.className = "tfsd";
    objParameterPrecision.readOnly = true;
    objParameterPrecision.value = "";
    objParameterScale.className = "tfsd";
    objParameterScale.readOnly = true;
    objParameterScale.value = "";
    objParameterIsReadonly.disabled = true;
    objParameterIsReadonly.checked = false;
    objParameterDefaultValue.value = "";
    objParameterDefaultValue.className = "tfs";
    objParameterDefaultValue.disabled = false;
}

function ddlParameterDataType_OnChange(obj)
{
    dataTypeValue = trim(obj.value.toLowerCase());
    objParameterLength.className = "tfsd";
    objParameterLength.readOnly = true;
    objParameterLength.value = "";
    objParameterPrecision.className = "tfsd";
    objParameterPrecision.readOnly = true;
    objParameterPrecision.value = "";
    objParameterScale.className = "tfsd";
    objParameterScale.readOnly = true;
    objParameterScale.value = "";
    var selectedDataType = null;
    for (var i=0; i<dataTypes.length; i++)
    {
        if (dataTypes[i].Name.toLowerCase() == dataTypeValue)
        {
            selectedDataType = dataTypes[i];
            break;
        }
    }    
    if (selectedDataType != null)
    {
        var isOriginalDataType = false;            
        objParameterLength.value = selectedDataType.DefaultLength;
        if (selectedDataType.IsUserDefinedTableType)
        {
            objParameterIsReadonly.checked = true;
            objParameterDefaultValue.value = "";
            objParameterDefaultValue.className = "tfsd";
            objParameterDefaultValue.readOnly = true;
        }
        else
        {
            objParameterIsReadonly.checked = false;
            objParameterDefaultValue.value = "";
            objParameterDefaultValue.className = "tfs";
            objParameterDefaultValue.readOnly = false;
        }
        if (selectedDataType.IsLengthEditable)
        {
            objParameterLength.className = "tfs";
            objParameterLength.readOnly = false;
        }
        else
        {
            objParameterLength.className = "tfsd";
            objParameterLength.readOnly = true;
        }
        objParameterPrecision.value = selectedDataType.DefaultPrecision;
        if (selectedDataType.IsPrecisionEditable)
        {
            objParameterPrecision.className = "tfs";
            objParameterPrecision.readOnly = false;
        }
        else
        {
            objParameterPrecision.className = "tfsd";
            objParameterPrecision.readOnly = true;
        }
        objParameterScale.value = selectedDataType.DefaultScale;
        if (selectedDataType.IsScaleEditable)
        {
            objParameterScale.className = "tfs";
            objParameterScale.readOnly = false;
        }
        else
        {
            objParameterScale.className = "tfsd";
            objParameterScale.readOnly = true;
        }

        if (parameterMode == "E")
        {
            if (selectedDataType.Name.toLowerCase() == parameterToBeEdited.dataType.toLowerCase())
            {
                isOriginalDataType = true;  
            }
        }

        if (isOriginalDataType)
        {
            objParameterLength.value = parameterToBeEdited.length;
            objParameterPrecision.value = parameterToBeEdited.precision;
            objParameterScale.value = parameterToBeEdited.scale;
        }
        else
        {
            objParameterLength.value = selectedDataType.DefaultLength;
            objParameterPrecision.value = selectedDataType.DefaultPrecision;
            objParameterScale.value = selectedDataType.DefaultScale;
        }
    }
}

function btnSaveParameter_OnClick()
{
    if (ValidateParameter())
    {
        if (parameterMode == "A")
        {
           btnNewParameter_OnClick(); 
        }
        else
        {
            btnCancelParameter_OnClick();
        }    
    }
    return false;
}

function btnCancelParameter_OnClick()
{
    HideAddEditParameterPanel();
    return false;
}


function btnSaveParameter_OnClick()
{
    if (ValidateParameter())
    {
        if (parameterMode == "A")
        {
           btnNewParameter_OnClick(); 
        }
        else
        {
            btnCancelParameter_OnClick();
        }    
    }
    return false;
}

function btnCancelParameter_OnClick()
{
    HideAddEditParameterPanel();
    return false;
}

function ValidateParameter()
{
    objParameterName.value = trim(objParameterName.value);
    objParameterDataType.value = trim(objParameterDataType.value);
    objParameterLength.value = trim(objParameterLength.value);
    objParameterPrecision.value = trim(objParameterPrecision.value);
    objParameterScale.value = trim(objParameterScale.value);
    dataTypeText = "";
    if (objParameterName.value == "") 
    { 
        alert("Parameter name is required.");
        objParameterName.focus();
        return false;
    }    
    //Check for valid column name
    //First character can only be @.
    paramName = objParameterName.value;
    firstChar = paramName.charAt(0).toLowerCase();
    if (firstChar != "@")
    {
        alert("Invalid parameter name. Parameter name must begin with an at sign (@)");
        objParameterName.select();
        return false;
    }
    if (paramName.length < 2)
    {
        alert("Invalid parameter name length.");
        objParameterName.select();
        return false;
    }
    for (var i=1; i<paramName.length; i++)
    {
        characterValue = paramName.charAt(i).toLowerCase();
        if (! ((characterValue >= '0' && characterValue <= 9) || (characterValue >= 'a' && characterValue <= 'z') || (characterValue == '_')))
        {   
            alert("Invalid parameter name.");
            objParameterName.select();
            return false;
        }
    }
    //Check for duplicate parameter name
    for (var i=0; i<parameters.length; i++)
    {
        if ( (parameters[i].name.toLowerCase() == objParameterName.value.toLowerCase()) )
        {
            if ((! parameters[i].isParameterDeleted) && (i != parameterRowIndex))
            {
                alert("Duplicate parameter name found. Parameter names must be unique in a function.");
                objParameterName.select();
                return false;
            }
        }
    }
    if (objParameterDataType.value == "") 
    { 
        alert("Parameter data type is required. Data type is ignored if the parameter is a cursor.");
        objParameterDataType.focus();
        return false;
    }    
    var selectedDataType = null;
    for (var i=0; i<dataTypes.length; i++)
    {
        if (dataTypes[i].Name.toLowerCase() == objParameterDataType.value.toLowerCase())
        {
            selectedDataType = dataTypes[i];
            break;
        }
    }    
    if (selectedDataType != null)
    {
        if (selectedDataType.IsLengthEditable)
        {
            minLength = selectedDataType.MinimumLength;
            maxLength = selectedDataType.MaximumLength;
            if (! CheckInteger(objParameterLength, minLength, maxLength))
            {
                objParameterLength.select();
                return false;
            }
        }
        if (selectedDataType.IsPrecisionEditable)
        {
            minPrecision = selectedDataType.MinimumPrecision;
            maxPrecision = selectedDataType.MaximumPrecision;
            if (! CheckInteger(objParameterPrecision, minPrecision, maxPrecision))
            {
                objParameterPrecision.select();
                return false;
            }
        }
        if (selectedDataType.IsScaleEditable)
        {
            minScale = selectedDataType.MinimumScale;
            maxScale = selectedDataType.MaximumScale;
            if (! CheckInteger(objParameterScale, minScale, maxScale))
            {
                objParameterScale.select();
                return false;
            }
        }
        if (selectedDataType.IsPrecisionEditable && selectedDataType.IsScaleEditable)
        {
            if (objParameterPrecision.value != "" && objParameterScale.value != "")
            {
                if (parseInt(objParameterPrecision.value, 10) <= parseInt(objParameterScale.value, 10))
                {
                    alert("Precision value should be greater than scale value");
                    objParameterScale.select();
                    return false;
                }
            }
        }
        dataTypeText = selectedDataType.Format;
        dataTypeText = dataTypeText.replace("$Name$", selectedDataType.Name);
        dataTypeText = dataTypeText.replace("$Length$", objParameterLength.value);
        dataTypeText = dataTypeText.replace("$Precision$", objParameterPrecision.value);
        dataTypeText = dataTypeText.replace("$Scale$", objParameterScale.value);
    }
    if (parameterMode == "A")
    {
        var par = new Parameter(-1, objParameterName.value, objParameterDataType.value, dataTypeText, objParameterLength.value, objParameterPrecision.value, objParameterScale.value, objParameterIsReadonly.checked, objParameterDefaultValue.value);
        parameters[parameters.length] = par;
        PaintNewParameterRow(par, parameters.length-1);
    }
    else if (parameterMode == "E")
    {
        var par = new Parameter(parameterToBeEdited.id, objParameterName.value, objParameterDataType.value, dataTypeText, objParameterLength.value, objParameterPrecision.value, objParameterScale.value, objParameterIsReadonly.checked, objParameterDefaultValue.value);
        parameters[parameterRowIndex] = par;
        PaintEditParameterRow(par, parameterRowIndex);
    }
    return true;
}

function PaintEditParameterRow(thisParameter, rowIndex)
{
    if (isIE)
    {
        tr = document.getElementById("par_" + rowIndex);
        //Parameter name
        td = tr.cells(0);
        td.innerHTML = thisParameter.name;
        //Parameter Data Type;
        td = tr.cells(1);
        td.innerHTML = thisParameter.dataTypeText;
        //Default value
        td = tr.cells(2);
        td.innerHTML = thisParameter.defaultValue;
    }
}

function PaintNewParameterRow(newParameter, thisParameterIndex)
{
    if (isIE)
    {
        tr = objParametersTable.insertRow();
        rowid = "par_" + thisParameterIndex;
        tr.id = rowid;
        tr.setAttribute("name", rowid);
        //Parameter Name;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newParameter.name;
        //Parameter Data Type;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newParameter.dataTypeText;
        //Default Value;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newParameter.defaultValue;
        //Edit & Delete
        editHTML = "<a href='#' onClick='EditParameter(" + thisParameterIndex + ")' title='Edit Parameter'>" + editText + "</a>";
        deleteHTML = "<a href='#' onClick='DeleteParameter(" + thisParameterIndex + ")' title='Delete Parameter'>" + deleteText + "</a>";
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = editHTML + "&nbsp;&nbsp;" + deleteHTML;
    }
}

function EditParameter(parameterIndex)
{
    try
    {
        InitializeAddEditParameterPanel();
        parameterRowIndex = parameterIndex;
        parameterToBeEdited = parameters[parameterIndex];
        parameterMode = "E";
        objParameterName.value = parameterToBeEdited.name;
        objParameterDataType.value = parameterToBeEdited.dataType;
        ddlParameterDataType_OnChange(objParameterDataType);
        objParameterLength.value = parameterToBeEdited.length;
        objParameterPrecision.value = parameterToBeEdited.precision;
        objParameterScale.value = parameterToBeEdited.scale;
        objParameterIsReadonly.checked = parameterToBeEdited.isReadOnly;
        if (objParameterIsReadonly.checked)
        {
            objParameterDefaultValue.value = "";
            objParameterDefaultValue.className = "tfsd";
            objParameterDefaultValue.readOnly = true;
        }
        else
        {
            objParameterDefaultValue.className = "tfs";
            objParameterDefaultValue.readOnly = false;
        }
        objParameterDefaultValue.value = parameterToBeEdited.defaultValue;
        objAddEditParameterPanel.style.display = "block";
        objParameterName.select();
        CenterIt(objAddEditParameterPanel);
    }
    catch (e)
    {
    }
}

function DeleteParameter(parameterIndex)
{
    thisParameter = parameters[parameterIndex];
    var confirmDelete = true;
    if (thisParameter.id >= 0)
    {
        confirmDelete = window.confirm("Are you sure you want to delete this parameter?");
    }
    if (confirmDelete)
    {
        thisParameter.isParameterDeleted = true;
        parameters[parameterIndex] = thisParameter;
        rowObjId = "par_" + parameterIndex;
        rowObj = document.getElementsByName(rowObjId)[0];
		if (isIE) { ri = rowObj.rowIndex; objParametersTable.deleteRow(ri); }
		else { deletedRow = objParametersTable.removeChild(rowObj); }
    }
}
