﻿var havingClauses = new Array();
var divGroupingPanel = null;
var ddlGroupingCol = null;
var btnGroupingFn = null;
var ddlGroupingFn = null;
var ddlGroupingCondi = null;
var tbGroupingValue = null;
var ddlGroupingNlc = null;
var rbGroupingEnc = null;
var hidGroupingRowNum = null;
var btnGroupingSave = null;

function InitializeGroupingPanel()
{
    divGroupingPanel = document.getElementsByName("pnlAddEditGrouping")[0];
    ddlGroupingCol = document.getElementsByName("ddlcolaegr")[0];
    btnGroupingFn = document.getElementsByName("btnfncaegr")[0];
    ddlGroupingFn = document.getElementsByName("ddlgrpfaegr")[0];
    ddlGroupingCondi = document.getElementsByName("ddlconaegr")[0];
    tbGroupingValue = document.getElementsByName("tbvalueaegr")[0];
    ddlGroupingNlc = document.getElementsByName("ddlnlcaegr")[0];
    rbGroupingEnc = document.getElementsByName("rbencloaegr");
    hidGroupingRowNum = document.getElementsByName("aegrrownum")[0];
    btnGroupingSave = document.getElementsByName("btnsaveaegr")[0];
}

function HavingClause(columnName, groupingFunction, condition, value, connector, enclosure)
{
    this.columnName = columnName;
    this.groupingFunction = groupingFunction;
    this.condition = condition;
    this.value = value;
    this.connector = connector;
    this.enclosure = enclosure;
    this.havingClauseText = columnName + " " + condition + " " + value;
    if (groupingFunction != "")
    {
        if (groupingFunction.toUpperCase().indexOf(" DISTINCT") > 0)
        {
            groupingFunctionArray = groupingFunction.split(" ");
            tmpGroupString = "";
            for (var i=0; i<groupingFunctionArray.length-1; i++)
            {
                tmpGroupString += groupingFunctionArray[i] + " ";
            }
            this.havingClauseText = trim(tmpGroupString) + "(" + groupingFunctionArray[length] + " " + columnName + ")" + " " + condition + " " + value;
        }
        else
        {
            this.havingClauseText = groupingFunction + "(" + columnName + ")" + " " + condition + " " + value;
        }
    }
    if (this.enclosure == "L")
    {
        this.havingClauseText = "(" + this.havingClauseText;
    }
    else if (this.enclosure == "R")
    {
        this.havingClauseText += this.havingClauseText + ")";
    }
    else if (this.enclosure == "O")
    {
        this.havingClauseText = "(" + this.havingClauseText + ")";
    }
}


function RepopulateGroupingColumnRows()
{
    
    var tmpColumnNamesListForSelect = new Array();
    for (var i=0; i<dbColumns.length; i++)
    {
        tmpColumnNamesListForSelect[tmpColumnNamesListForSelect.length] = dbColumns[i].columnDisplayName;
    }
    thisDropDownList = ddlGroupingCol;
    thisDropDownListValue = thisDropDownList.value;
    FillDropDownList(thisDropDownList, thisDropDownListValue, tmpColumnNamesListForSelect, tmpColumnNamesListForSelect, true);

}

function btnAddGrouping_OnClick()
{
    if (dbColumns.length == 0) { alert("Please select some tables first"); ReplicateBodyOnLoad(); return false;}
    
    var tmpColumnNamesListForSelect = new Array();
    for (var i=0; i<dbColumns.length; i++)
    {
        tmpColumnNamesListForSelect[tmpColumnNamesListForSelect.length] = dbColumns[i].columnDisplayName;
    }
    
    FillDropDownList(ddlGroupingCol, "", tmpColumnNamesListForSelect, tmpColumnNamesListForSelect, true);
    ddlcolaegr_OnChange(ddlGroupingCol);
    ShowPopups_AddEditGroupingCondition();
}


function ShowPopups_AddEditGroupingCondition()
{
    divGroupingPanel.style.display = "block";
    CenterIt(divGroupingPanel);
    ddlGroupingCol.focus();
}

function HidePopups_AddEditGroupingCondition()
{
    tbGroupingValue.value = "";
    ddlGroupingFn.options.length = 0;
    ddlGroupingNlc.selectedIndex = 0;
    hidGroupingRowNum.value = "-1";
    divGroupingPanel.style.display = "none";
    for (var i=0; i<rbGroupingEnc.length; i++)
    {
        rbGroupingEnc[i].checked = false;
    }
    HidePopups_AddFunction();
}

function ddlcolaegr_OnChange(obj)
{
    arrayToUse = new Array();
    btnGroupingFn.disabled = false;
    if (dbColumns[obj.selectedIndex].isColumnNumeric)
    {
        arrayToUse = groupingFunctionsNumericColumns;
    }
    if (dbColumns[obj.selectedIndex].isColumnNonNumeric)
    {
        arrayToUse = groupingFunctionsNonNumericColumns;
    }
    if (dbColumns[obj.selectedIndex].isAllColumns)
    {
        arrayToUse = groupingFunctionsAllColumns;
        btnGroupingFn.disabled = true;//can't define a function on all columns
    }
    var arrayToUse2 = new Array();
    for (var i=1; i<arrayToUse.length; i++)
    {
        arrayToUse2[arrayToUse2.length] = arrayToUse[i];
    }
    FillDropDownList(ddlGroupingFn, "", arrayToUse2, arrayToUse2, true);
}

function btnfncaegr_OnClick(obj)
{
    columnNamesList = columnNamesListForSelect;
    ShowPopups_AddFunction("ddlcolaegr", obj, "btnfncaegr", 0);
}

function btnsaveaegr_OnClick()
{
    rowNumber = parseInt(hidGroupingRowNum.value, 10);
    isNewRow = hidGroupingRowNum.value == "-1";
    col = trim(ddlGroupingCol.value);
    grpf = trim(ddlGroupingFn.value);
    cond = trim(ddlGroupingCondi.value);
    val = trim(tbGroupingValue.value);
    nlc = trim(ddlGroupingNlc.value);
    enc = "";
    for (var i=0; i<rbGroupingEnc.length; i++)
    {
        if (rbGroupingEnc[i].checked)
        {
            enc = rbGroupingEnc[i].value;
            break;
        }
    }
    if (val.length == 0)
    {
        alert("Please specify a value or sub query for the grouping condition");
        tbGroupingValue.focus();
        return false;
    }
    if (havingClauses.length != 0)
    {
        if (isNewRow) 
        { 
            rowNumberBefore = havingClauses.length - 1; 
            rowNumberAfter = -1;
        }
        else 
        {
            rowNumberBefore = rowNumber - 1;
            rowNumberAfter = (rowNumber == havingClauses.length-1) ? -1 : rowNumber + 1;
        }
        errorInConnector = false;
        connectorErrorMessage = "";
        if (rowNumberBefore >= 0)
        {
            if (havingClauses[rowNumberBefore].connector == "")
            {
                connectorErrorMessage = "Please make sure that previous grouping condition has a connector defined to link with this grouping condition, else your query will fail.\n";
                errorInConnector = true;
            }
        }
        if (rowNumberAfter >= 1)
        {
            if (nlc == "")
            {
                connectorErrorMessage += "Please make sure that this grouping condition has a connector defined to link with next grouping condition, else your query will fail.\n";
                errorInConnector = true;
            }
        }
        if (errorInConnector)
        {
            alert(connectorErrorMessage);
        }
    }

    var tempHavingClause = new HavingClause(col, grpf, cond, val, nlc, enc);
    if (isNewRow)
    {
        havingClauses[havingClauses.length] = tempHavingClause;
        AddNewGroupingRow();        
    }
    else
    {
        havingClauses[rowNumber] = tempHavingClause;
        EditGroupingRow(rowNumber);        
    }
    HidePopups_AddEditGroupingCondition();
    return false;
}

function btncancelaegr_OnClick()
{
    HidePopups_AddEditGroupingCondition();
    return false;
}

function AddNewGroupingRow()
{
    thisHavingClause = havingClauses[havingClauses.length-1];
    
    btnf2 = document.createElement("input");
    btnf2.type = "button";
    btnf2.className = "btns";
    btnf2.value = "E";
    btnf2.style.cssText = "width: 16px; height: 16px;";
    btnf2.id = "btnedgr";
    btnf2.setAttribute("name", "btnedgr");
    btnf2.setAttribute("title", "Click here to edit this grouping condition");
        
    bd = document.createElement("input");
    bd.type = "button";
    bd.className = "btns";
    bd.value = "X";
    bd.style.cssText = "width: 16px; height: 16px;";
    bd.id = "delgrp";
    bd.setAttribute("name", "delgrp");
    bd.setAttribute("title", "Click here to delete this grouping condition");
    if (isIE)
    {
        btnf2.onclick = function () { btnEditGroupingRow_OnClick() };
        bd.onclick = function () { btnDeleteGroupingRow_OnClick() };        

        tr = groupingTable.insertRow();
        tr.id = "grr";
        tr.setAttribute("name", "grr");

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(btnf2);

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(bd);
        
		td = tr.insertCell();
        td.id = "grtd1";
        td.setAttribute("name", "grtd1");
		td.vAlign = "top";
		td.align = "left";
		td.className = "fes";
		td.innerText = thisHavingClause.havingClauseText;

		td = tr.insertCell();
        td.id = "grtd2";
        td.setAttribute("name", "grtd2");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerHTML = thisHavingClause.connector;
    }
    else
    {
        btnf2.setAttribute("onClick", "btnEditGroupingRow_OnClick(this)");
        bd.setAttribute("onclick", "btnDeleteGroupingRow_OnClick(this)");
        
		tr = document.createElement("tr");
        tr.id = "grr";
        tr.setAttribute("name", "grr");

		td = document.createElement("td");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(btnf2);

		td = document.createElement("td");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(bd);

		td = document.createElement("td");
		tr.appendChild(td);
        td.id = "grtd1";
        td.setAttribute("name", "grtd1");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerText = thisHavingClause.havingClauseText;

		td = document.createElement("td");
		tr.appendChild(td);
        td.id = "grtd2";
        td.setAttribute("name", "grtd2");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerHTML = thisHavingClause.connector;
		
		groupingTable.appendChild(tr);	
		
    }  
    return false;
}

function EditGroupingRow(rowNum)
{
    thisHavingClause = havingClauses[rowNum];
    document.getElementsByName("grtd1")[rowNum].innerText = thisHavingClause.havingClauseText;
    document.getElementsByName("grtd2")[rowNum].innerText = thisHavingClause.connector;
    return false;
}

function btnEditGroupingRow_OnClick(obj)
{
    rowIndex = -1;
    if (isIE)
    {
        rowIndex = event.srcElement.parentElement.parentElement.rowIndex - 1;
    }
    else
    {
        for (var i=0; i<document.getElementsByName("btnedgr").length; i++)
        {
            if (document.getElementsByName("btnedgr")[i] == obj)
            {
                rowIndex = i;
                break;
            }
        }
    }
    if (rowIndex > -1)
    {
        thisHavingClause = havingClauses[rowIndex];
        col = thisHavingClause.columnName;
        grpf = thisHavingClause.groupingFunction;
        cond = thisHavingClause.condition;
        val = thisHavingClause.value;
        nlc = thisHavingClause.connector;
        enc = thisHavingClause.enclosure;
        var tmpColumnNamesListForSelect = new Array();
        for (var i=0; i<dbColumns.length; i++)
        {
            if (col.toUpperCase().indexOf(dbColumns[i].columnDisplayName.toUpperCase()) >= 0)
            {
                tmpColumnNamesListForSelect[tmpColumnNamesListForSelect.length] = thisHavingClause.columnName;
            }
            else
            {
                tmpColumnNamesListForSelect[tmpColumnNamesListForSelect.length] = dbColumns[i].columnDisplayName;
            }    
        }
        FillDropDownList(ddlGroupingCol, col, tmpColumnNamesListForSelect, tmpColumnNamesListForSelect, true);
        ddlcolaegr_OnChange(ddlGroupingCol);
        hidGroupingRowNum.value = rowIndex;
        ddlGroupingCondi.value = cond;
        tbGroupingValue.value = val;
        ddlGroupingNlc.value = nlc;
        ddlGroupingFn.value = grpf;
        if (enc != "")
        {
            for (var i=0; i<rbGroupingEnc.length; i++)
            {
                if (rbGroupingEnc[i].value == enc)
                {
                    rbGroupingEnc[i].checked = true;
                    break;
                }
            }
        }
        ShowPopups_AddEditGroupingCondition();
    }
    return false;
}

function btnDeleteGroupingRow_OnClick(obj)
{
    if (isIE)
    {
        rowIndex = event.srcElement.parentElement.parentElement.rowIndex - 1;
        groupingTable.deleteRow(rowIndex+1);
    }
    else
    {
        for (var i=0; i<document.getElementsByName("delgrp").length; i++)
        {
            if (document.getElementsByName("delgrp")[i] == obj)
            {
                rowIndex = i;
                groupingTable.removeChild(document.getElementsByName("grr")[i]);
                break;
            }
        }
    }
    havingClauses = DeleteArrayElement(havingClauses, rowIndex);
}

function DeleteAllGroupingRows()
{
    numGroupingRows = document.getElementsByName("grr").length;
    for (var i=numGroupingRows-1; i>=0; i--)
    {
        if (isIE)
        {
            groupingTable.deleteRow(i+1);  
        }
        else
        {
            groupingTable.removeChild(document.getElementsByName("grr")[i]);
        }
    }
    havingClauses = new Array();
}

function DeleteGroupingRowsContainingTable(tableAlias)
{
    tableAlias += ".";
    //tableName = tableName + ".";
    for (var i=havingClauses.length-1; i>=0; i--)
    {
        if (havingClauses[i].columnName.toUpperCase().indexOf(tableAlias.toUpperCase()) >= 0)
        {
            havingClauses = DeleteArrayElement(havingClauses, i);
            if (isIE)
            {
                groupingTable.deleteRow(i+1);  
            }
            else
            {
                groupingTable.removeChild(document.getElementsByName("grr")[i]);
            }
        }
    }
}
