﻿var ddlJoinTable1 = null;
var ddlJoinTable2 = null;
var ddlJoinColumn1 = null;
var ddlJoinColumn2 = null;
var ddlJoinJoinType = null;
var divJoinsPanel = null;
var hidJoinRowNum = null;
var tableJoins = new Array();

function InitializeJoinsPanel()
{
    ddlJoinTable1 = document.getElementsByName("ddljttab1aej")[0];
    ddlJoinTable2 = document.getElementsByName("ddljttab2aej")[0];
    ddlJoinColumn1 = document.getElementsByName("ddljtcol1aej")[0];
    ddlJoinColumn2 = document.getElementsByName("ddljtcol2aej")[0];
    ddlJoinJoinType = document.getElementsByName("ddljtaej")[0];
    divJoinsPanel = document.getElementsByName("pnlAddEditJoinsPanel")[0];
    hidJoinRowNum = document.getElementsByName("aejrownum")[0];
}

function TableJoin(joinType, schema1, table1, table1alias, column1, schema2, table2, table2alias, column2, isAutoJoin)
{
    this.joinType = trim(joinType);
    this.schema1 = trim(schema1);
    this.table1 = trim(table1);
    this.table1alias = trim(table1alias);
    this.column1 = trim(column1);
    this.schema2 = trim(schema2);
    this.table2 = trim(table2);
    this.table2alias = trim(table2alias);
    this.column2 = trim(column2);
    this.isAutoJoin = isAutoJoin;
    this.columnJoins = new Array();
    this.tableJoinText = this.schema1 + "." + this.table1 + " AS " + this.table1alias;
    this.tableJoinText += " " + this.joinType + " "; 
    this.tableJoinText += this.schema2 + "." + this.table2 + " AS " + this.table2alias;
    if (this.column1 != "" && this.column2 != "")
    {
        this.columnJoins[0] = this.table1alias + "." + this.column1 + " = " + this.table2alias + "." + this.column2;
        this.tableJoinText += " ON "; 
        this.tableJoinText += this.columnJoins.join(" AND "); 
    }
}

function RebuildTableJoinText(tableJoinObj)
{
    tableJoinObj.tableJoinText = tableJoinObj.schema1 + "." + tableJoinObj.table1 + " AS " + tableJoinObj.table1alias;
    tableJoinObj.tableJoinText += " " + tableJoinObj.joinType + " "; 
    tableJoinObj.tableJoinText += tableJoinObj.schema2 + "." + tableJoinObj.table2 + " AS " + tableJoinObj.table2alias;
    if (tableJoinObj.column1 != "" && tableJoinObj.column2 != "")
    {
        tableJoinObj.tableJoinText += " ON "; 
        tableJoinObj.tableJoinText += tableJoinObj.columnJoins.join(" AND "); 
    }
    return tableJoinObj;
}

function DeleteAllJoinRows()
{
    numJoinRows = document.getElementsByName("jcr").length;
    for (var i=numJoinRows-1; i>=0; i--)
    {
        if (isIE)
        {
            joinsTable.deleteRow(i);  
        }
        else
        {
            joinsTable.removeChild(document.getElementsByName("jcr")[i]);
        }
    }
    tableJoins = new Array();
}

function DeleteJoinRowsContainingTable(tableAlias)
{
    for (var i=tableJoins.length-1; i>=0; i--)
    {
        if ((tableJoins[i].table1alias == tableAlias) || (tableJoins[i].table2alias == tableAlias))
        {
            tableJoins = DeleteArrayElement(tableJoins, i);
            if (isIE)
            {
                joinsTable.deleteRow(i+1);  
            }
            else
            {
                joinsTable.removeChild(document.getElementsByName("jcr")[i]);
            }
        }
    }
}


function DeleteJoinRow(obj)
{
    if (isIE)
    {
        obj = event.srcElement;
        parentRow = obj.parentElement.parentElement;
        joinRowIndex = parentRow.rowIndex;
        joinsTable.deleteRow(joinRowIndex);   
        tableJoins = DeleteArrayElement(tableJoins, joinRowIndex-1);  
    }
    else
    {
        deleteButtons = document.getElementsByName("delj");
        for(var i=0; i<deleteButtons.length; i++)
        {
            if (deleteButtons[i] == obj)
            {
                joinsTable.removeChild(document.getElementsByName("jcr")[i]);
                tableJoins = DeleteArrayElement(tableJoins, i);  
            }
        }
    }
}

function btnAddJoin_OnClick()
{
    if (dbColumns.length == 0) { alert("Please select some tables first"); ReplicateBodyOnLoad(); return false;}
    if (databaseObjects.length < 2) { alert("At least two tables must be selected first"); ReplicateBodyOnLoad(); return false;}
    InsertNewJoinRow();
    return false;
}

function ddljttab1aej_OnChange(obj)
{
    if (obj.selectedIndex > 0 && obj.selectedIndex == ddlJoinTable2.selectedIndex)
    {
        alert("Same table can not be selected for creating a join condition");
        obj.focus();
        return false;
    }
    RefillColumnsDropdownForJoins(ddlJoinColumn1, obj.selectedIndex, "");
    return false;
}

function ddljttab2aej_OnChange(obj)
{
    if (obj.selectedIndex > 0 && obj.selectedIndex == ddlJoinTable1.selectedIndex)
    {
        alert("Same table can not be selected for creating a join condition");
        obj.focus();
        return false;
    }
    RefillColumnsDropdownForJoins(ddlJoinColumn2, obj.selectedIndex, "");
    return false;
}

function RefillColumnsDropdownForJoins(columnsDropDownToFill, tableObjectIndex, selectedColumnValue)
{
    columnsDropDownToFill.options.length = 0;//clear all columns list
    tableObjectIndex -= 1;
    if (tableObjectIndex >= 0)
    {
        tableAlias = databaseObjects[tableObjectIndex].alias;
        startIndex = -1;
        endIndex = -1;
        for (var j=0; j<dbColumns.length; j++)
        {
            if (dbColumns[j].tableAlias == tableAlias && startIndex == -1)
            {
                startIndex = j+1;
            }
            if (dbColumns[j].tableAlias != tableAlias && startIndex != -1 && endIndex == -1)
            {
                endIndex = j;
            }
            if (startIndex != -1 && endIndex != -1)
            {
                break;
            }            
        }
        if (endIndex == -1)
        {
            endIndex = dbColumns.length;
        }
        if (startIndex != -1 && endIndex != -1)
        {
            var columnsArrayForJoins = new Array();
            for (var j=startIndex; j<endIndex; j++)
            {
               columnsArrayForJoins[columnsArrayForJoins.length] =  dbColumns[j].columnDisplayName;
            }
            columnsArrayForJoins.unshift("-");
            FillDropDownList(columnsDropDownToFill, selectedColumnValue, columnsArrayForJoins, columnsArrayForJoins, true);
        }            
    }    
}

function ShowPopups_AddJoin(targetRowNumber)
{
    var trueFalseCondition = true;
    if (targetRowNumber < 0 || targetRowNumber > tableJoins.length) { trueFalseCondition = false; }
    else if (! tableJoins[targetRowNumber].isAutoJoin) { trueFalseCondition = false; }
    ddlJoinTable1.disabled = trueFalseCondition;
    ddlJoinTable2.disabled = trueFalseCondition;
    ddlJoinColumn1.disabled = trueFalseCondition;
    ddlJoinColumn2.disabled = trueFalseCondition;
    divJoinsPanel.style.display = "block";
    hidJoinRowNum.value = targetRowNumber;
    ddlJoinJoinType.focus();
    CenterIt(divJoinsPanel);
    if (targetRowNumber >=0 && targetRowNumber < tableJoins.length)
    {
        var thisTableJoin = tableJoins[targetRowNumber];
        ddlJoinJoinType.value = thisTableJoin.joinType;
        for (var i=0; i<databaseObjects.length; i++)
        {
            if (databaseObjects[i].alias == thisTableJoin.table1alias) { ddlJoinTable1.selectedIndex = i+1; RefillColumnsDropdownForJoins(ddlJoinColumn1, i+1, thisTableJoin.table1alias + "." + thisTableJoin.column1);}
            if (databaseObjects[i].alias == thisTableJoin.table2alias) { ddlJoinTable2.selectedIndex = i+1; RefillColumnsDropdownForJoins(ddlJoinColumn2, i+1, thisTableJoin.table2alias + "." + thisTableJoin.column2);}
        }      
    }
}

function HidePopups_AddEditJoin()
{
   hidJoinRowNum.value = -1;
   ddlJoinTable1.options.length = 0;
   ddlJoinTable2.options.length = 0;
   ddlJoinColumn1.options.length = 0;
   ddlJoinColumn2.options.length = 0;
   divJoinsPanel.style.display = "none";
}

function CreateJoinConditionRow(thisJoinCondition)
{
    bej = document.createElement("input");
    bej.type = "button";
    bej.className = "btns";
    bej.value = "E";
    bej.style.cssText = "width: 16px; height: 16px;";
    bej.id = "editj";
    bej.setAttribute("name", "editj");
    
    bd = document.createElement("input");
    bd.type = "button";
    bd.className = "btns";
    bd.value = "X";
    bd.style.cssText = "width: 16px; height: 16px;";
    bd.id = "delj";
    bd.disabled = thisJoinCondition.isAutoJoin;
    bd.setAttribute("name", "delj");
    if (isIE)
    {
        bd.onclick = function () { DeleteJoinRow()};
        bej.onclick = function () { btnEditJoinRow_OnClick()};
        tr = joinsTable.insertRow();
        tr.id = "jcr";
        tr.setAttribute("name", "jcr");

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.appendChild(bej);

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.appendChild(bd);

		td = tr.insertCell();
		td.id = "jotxtcl";
		td.setAttribute("name", "jotxtcl");
		td.vAlign = "top";
		td.align = "left";
		td.className = "fes";
		td.innerHTML = thisJoinCondition.tableJoinText;
    }
    else
    {
        bd.setAttribute("onClick", "DeleteJoinRow(this)");
        bej.setAttribute("onClick", "btnEditJoinRow_OnClick(this)");

		tr = document.createElement("tr");
		tr.id = "jcr";
		tr.setAttribute("name", "jcr");

		td = document.createElement("td");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.appendChild(bej);
		tr.appendChild(td);

		td = document.createElement("td");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.appendChild(bd);
		tr.appendChild(td);

		td = document.createElement("td");
		td.id = "jotxtcl";
		td.setAttribute("name", "jotxtcl");
		td.vAlign = "top";
		td.align = "left";
		td.className = "fes";
		td.innerHTML = thisJoinCondition.tableJoinText;
		tr.appendChild(td);
		
		joinsTable.appendChild(tr);	
    }    
}

function btnEditJoinRow_OnClick(obj)
{
    var joinRowNumber = -1;
    if (isIE)
    {
        joinRowNumber = event.srcElement.parentElement.parentElement.rowIndex - 1;
    }
    else
    {
        for (var i=0; i<document.getElementsByName("editj").length; i++)
        {
            if (obj == document.getElementsByName("editj")[i])
            {
                joinRowNumber = i;
                break;
            }
        }
    }
    if (joinRowNumber >= 0)
    {
        FillJoinDropDowns();
        ShowPopups_AddJoin(joinRowNumber)
    }
}


function FillJoinDropDowns()
{
    FillDropDownList(ddlJoinJoinType, "", joinTypes, joinTypes, true);
    var dbObjectsArrayForJoins = new Array();
    for (var i=0; i<databaseObjects.length; i++)
    {
        dbObjectsArrayForJoins[dbObjectsArrayForJoins.length] = databaseObjects[i].displayName + " (" + databaseObjects[i].alias + ")";
    }    
    dbObjectsArrayForJoins.unshift("-");
    FillDropDownList(ddlJoinTable1, "", dbObjectsArrayForJoins, dbObjectsArrayForJoins, true);
    FillDropDownList(ddlJoinTable2, "", dbObjectsArrayForJoins, dbObjectsArrayForJoins, true);
    RefillColumnsDropdownForJoins(ddlJoinColumn1, -1);
    RefillColumnsDropdownForJoins(ddlJoinColumn2, -1);
}

function InsertNewJoinRow()
{
    FillJoinDropDowns();
    ShowPopups_AddJoin(-1);
}

function btncancelaej_OnClick()
{
    HidePopups_AddEditJoin();
}
function btnsaveaej_OnClick()
{
    if (! ValidateJoinCondition())
    {
        return false;
    }
    var joinRowNum = parseInt(hidJoinRowNum.value, 10);
    var thisJoinType = ddlJoinJoinType.value;
    var table1Index = ddlJoinTable1.selectedIndex;
    var table2Index = ddlJoinTable2.selectedIndex;
    var col1Index = ddlJoinColumn1.selectedIndex;
    var col2Index = ddlJoinColumn2.selectedIndex;
    var databaseObject1 = databaseObjects[table1Index-1];
    var databaseObject2 = databaseObjects[table2Index-1];
    var table1schema = databaseObject1.schema;
    var table1name = databaseObject1.name;
    var table1alias = databaseObject1.alias;
    var col1withalias = ddlJoinColumn1.value;
    var col1name = col1withalias.substring(table1alias.length+1);
    var table2schema = databaseObject2.schema;
    var table2name = databaseObject2.name;
    var table2alias = databaseObject2.alias;
    var col2withalias = ddlJoinColumn2.value;
    var col2name = col2withalias.substring(table2alias.length+1);
    if (joinRowNum == -1)//its a new one
    {
        var indexOfExistingTableJoin = CheckForExistingTablesInJoins(table1alias, table2alias);
        if (indexOfExistingTableJoin == -1)
        {
            var tempTableJoin = new TableJoin(thisJoinType, table1schema, table1name, table1alias, col1name, table2schema, table2name, table2alias, col2name, false);
            tableJoins[tableJoins.length] = tempTableJoin;
            CreateJoinConditionRow(tempTableJoin);
        }
        else
        {
            var indexOfExistingColumnJoin = CheckForExistingColumnsInJoins(col1withalias, col2withalias);
            if (indexOfExistingColumnJoin >= 0) 
            { 
                var existingTableJoinRowNumber = indexOfExistingTableJoin + 1;
                alert("This columns used in this join are already used. Please refer to row #" + existingTableJoinRowNumber + " for details");
                return false;
            }    
            else
            {
                var tempTableJoin = tableJoins[indexOfExistingTableJoin];
                tempTableJoin.columnJoins[tempTableJoin.columnJoins.length] = col1withalias + " = " + col2withalias;
                tempTableJoin = RebuildTableJoinText(tempTableJoin);
                tableJoins[indexOfExistingTableJoin] = tempTableJoin;
                var joinTableCells = document.getElementsByName("jotxtcl");
                joinTableCells[indexOfExistingTableJoin].innerHTML = tempTableJoin.tableJoinText;
            }
        }
    }
    else
    {
        var isJoinAutoJoin = tableJoins[joinRowNum].isAutoJoin;
        if (isJoinAutoJoin)
        {
            tableJoins[joinRowNum].joinType = ddlJoinJoinType.value;
            tableJoins[joinRowNum] = RebuildTableJoinText(tableJoins[joinRowNum]);
            var joinTableCells = document.getElementsByName("jotxtcl");
            joinTableCells[joinRowNum].innerHTML = tableJoins[joinRowNum].tableJoinText; 
        }
    }
    HidePopups_AddEditJoin();
}

function ValidateJoinCondition()
{
    var table1Index = ddlJoinTable1.selectedIndex;
    var table2Index = ddlJoinTable2.selectedIndex;
    var col1Index = ddlJoinColumn1.selectedIndex;
    var col2Index = ddlJoinColumn2.selectedIndex;
    if (table1Index == 0)
    {
        alert("Please select first table for join");
        ddlJoinTable1.focus();
        return false;
    }
    if (col1Index == 0)
    {
        alert("Please select a column from the first table for join");
        ddlJoinColumn1.focus();
        return false;
    }
    if (table2Index == 0)
    {
        alert("Please select second table for join");
        ddlJoinTable2.focus();
        return false;
    }
    if (col2Index == 0)
    {
        alert("Please select a column from the second table for join");
        ddlJoinColumn2.focus();
        return false;
    }
    if (table1Index == table2Index)
    {
        alert("A table can be selected only once in a join condition. Please select two different tables.");
        ddlJoinTable2.focus();
        return false;
    }
    return true;
}

function ReverseTableJoin(aTableJoin)
{
    var joinType = trim(aTableJoin.joinType);
    var schema1 = trim(aTableJoin.schema1);
    var table1 = trim(aTableJoin.table1);
    var table1alias = trim(aTableJoin.table1alias);
    var column1 = trim(aTableJoin.column1);
    var schema2 = trim(aTableJoin.schema2);
    var table2 = trim(aTableJoin.table2);
    var table2alias = trim(aTableJoin.table2alias);
    var column2 = trim(aTableJoin.column2);
    var isAutoJoin = aTableJoin.isAutoJoin;
    var columnJoins = aTableJoin.columnJoins;
    for (var k=0; k<joinTypes.length; k++)
    {
        if (joinType == joinTypes[k])
        {
            joinType = reverseJoinValues[k];
            break;
        }
    }
    var tmp = schema1;
    schema1 = schema2;
    schema2 = tmp;
    
    tmp = table1;
    table1 = table2;
    table2 = tmp;
    
    tmp = table1alias;
    table1alias = table2alias;
    table2alias = tmp;
    
    tmp = column1;
    column1 = column2;
    column2 = tmp;

    for (var k=0; k<columnJoins.length; k++)
    {
        var thisColumnJoin = columnJoins[k];
        var thisColumnJoinArr = thisColumnJoin.split(" = ");
        thisColumnJoinArr = thisColumnJoinArr.reverse();
        thisColumnJoin = thisColumnJoinArr.join(" = ");
    }
    
    var tmpTableJoin = new TableJoin(joinType, schema1, table1, table1alias, column1, schema2, table2, table2alias, column2, isAutoJoin);
    tmpTableJoin.columnJoins = columnJoins;
    tmpTableJoin = RebuildTableJoinText(tmpTableJoin);
    return tmpTableJoin;
}

function BuildAllTableJoins()
{
    var tableJoinsText = "";
    var tablesNotIncludedInAnyJoins = new Array();
    for (var i=0; i<databaseObjects.length; i++)
    {
        var tableFoundInJoin = false;
        var dbObj = databaseObjects[i];
        for (var j=0; j<tableJoins.length; j++)
        {
            if ((dbObj.alias == tableJoins[j].table1alias) || (dbObj.alias == tableJoins[j].table2alias))
            {
               tableFoundInJoin = true;
               break; 
            }
        }
        if (! tableFoundInJoin)
        {
            tablesNotIncludedInAnyJoins[tablesNotIncludedInAnyJoins.length] = dbObj.displayName + " AS " + dbObj.alias;
        }
    }
    
    if (tableJoins.length <= 0)//if no joins are defined then all tables are joined under cross join.
    {
        var tmpArray = new Array();
        for (var i=0; i<databaseObjects.length; i++)
        {
            tmpArray[tmpArray.length] = databaseObjects[i].displayName + " AS " + databaseObjects[i].alias
        }
        tableJoinsText = tmpArray.join(" Cross Join ");
    }
    else if (tableJoins.length == 1)//Only one join condition is involved
    {
        tableJoinsText = tableJoins[0].tableJoinText;
        if (tablesNotIncludedInAnyJoins.length > 0)
        {
            tableJoinsText += " Cross Join " + tablesNotIncludedInAnyJoins.join(" Cross Join ");
        }    
    }
    else //More than one join condition is defined
    {
        var tableJoinsA = new Array();
        for (var i=0; i<tableJoins.length; i++)
        {
            tableJoinsA[tableJoinsA.length] = tableJoins[i];
        }
        var tableJoinsTextArray = new Array();
        while (tableJoinsA.length > 0)
        {
            var cntr = 0;
            var TIJ = new Array();
            TIJ[0] = tableJoinsA[cntr].table1alias;
            TIJ[1] = tableJoinsA[cntr].table2alias;
            var tableJoinsTextTemp = tableJoinsA[cntr].tableJoinText;
            tableJoinsA = DeleteArrayElement(tableJoinsA, 0);
            for (var i=0; i<TIJ.length; i++)
            {
                for (var j=tableJoinsA.length-1; j>=0; j--)
                {
                    var thisTableJoin = tableJoinsA[j];
                    var T1NXT = thisTableJoin.table1alias;
                    var T2NXT = thisTableJoin.table2alias;
                    if (TIJ[i] == T1NXT)
                    {
                        TIJ[TIJ.length] = T2NXT;
                        tableJoinsTextTemp += " " + thisTableJoin.joinType + " " + thisTableJoin.schema2 + "." + thisTableJoin.table2 + " AS " + thisTableJoin.table2alias + " ON "; 
                        tableJoinsTextTemp += " " + thisTableJoin.columnJoins.join(" AND ");
                        tableJoinsA = DeleteArrayElement(tableJoinsA, j);
                    }
                    else if (TIJ[i] == T2NXT)
                    {
                        TIJ[TIJ.length] = T1NXT;
                        thisTableJoin = ReverseTableJoin(thisTableJoin);
                        tableJoinsTextTemp += " " + thisTableJoin.joinType + " " + thisTableJoin.schema2 + "." + thisTableJoin.table2 + " AS " + thisTableJoin.table2alias + " ON "; 
                        tableJoinsTextTemp += " " + thisTableJoin.columnJoins.join(" AND ");
                        tableJoinsA = DeleteArrayElement(tableJoinsA, j);
                    }
                }
            }
            tableJoinsTextArray[tableJoinsTextArray.length] = tableJoinsTextTemp;
        }
        newlen = tablesNotIncludedInAnyJoins.unshift(tableJoinsTextArray.join(" Cross Join "));
        tableJoinsText = tablesNotIncludedInAnyJoins.join(" Cross Join ");
    }
    return tableJoinsText;
}
